<?php
namespace cloud\apps\netoff\object;

define('API_WXDENY_DIR', '/usr/logdata/api_wxdeny');

function is_utf8($word)   
{
	if (preg_match("/^([".chr(228)."-".chr(233)."]{1}[".chr(128)."-".chr(191)."]{1}[".chr(128)."-".chr(191)."]{1}){1}/",$word) == true || preg_match("/([".chr(228)."-".chr(233)."]{1}[".chr(128)."-".chr(191)."]{1}[".chr(128)."-".chr(191)."]{1}){1}$/",$word) == true || preg_match("/([".chr(228)."-".chr(233)."]{1}[".chr(128)."-".chr(191)."]{1}[".chr(128)."-".chr(191)."]{1}){2,}/",$word) == true)
	{
		return true;
	}else{   
		return false;   
	}   
}

function is_ipstr($ipstr)
{
	// 0.0.0.0 or 255.255.255.255
	// 0.0.0.0-255.255.255.255
	// 192.168.0.1/24
	$pat = "/^(((1?\d{1,2})|(2[0-4]\d)|(25[0-5]))\.){3}((1?\d{1,2})|(2[0-4]\d)|(25[0-5]))$/";
	if(preg_match($pat, $ipstr))
		return true;
	$pat = "/^((((1?\d{1,2})|(2[0-4]\d)|(25[0-5]))\.){3}((1?\d{1,2})|(2[0-4]\d)|(25[0-5])))-((((1?\d{1,2})|(2[0-4]\d)|(25[0-5]))\.){3}((1?\d{1,2})|(2[0-4]\d)|(25[0-5])))$/";
	if(preg_match($pat, $ipstr))
		return true;
	$pat = "/^((((1?\d{1,2})|(2[0-4]\d)|(25[0-5]))\.){3}((1?\d{1,2})|(2[0-4]\d)|(25[0-5])))\/(([1-9]?\d)|\d)$/";
	if(preg_match($pat, $ipstr))
		return true;
	return false;
}

function select($data)
{
	global $nidb, $user;
	
	
	$result = array(
		'page'	=> 0,
		'limit'	=> 0,
		'rows'	=> array()
	);

	$values = array();
	$optional = array();
	// set order, limit, offset value
	format_list_arg($data, $optional);

	format_and_push($data, 'grpid', $optional, '', 'int', false);

	// 设置用户组
	if(\cloud\apps\work\project\project_enable(array())) {
		$optional['grpid'] = \cloud\apps\work\project\in_work_grpidstr(1, $optional['grpid']);
		if($optional['grpid'] === false)
			return $result;
		if(empty($optional['grpid']) && !is_supadmin($user->username))
			return $result;
	}
	else {
		if (!is_supadmin($user->username)) {
			if($user->grp == '')
				return $result;
			if($optional['grpid'] <= 0)
				$optional['grpid'] = $user->grp;
			else {
				$grpids = explode(',', $user->grp);
				if(in_array($optional['grpid'], $grpids) == false) {
					return $result;
				}
			}

			if($optional['grpid'] == '')
				return $result;
		}
		else
		if($optional['grpid'] <= 0)
			$optional['grpid'] = '';
	}


	$where_str = '';
/*
	if(format_and_push($data, 'disabled', $optional, '', 'int', false))
		$where_str .= "`disabled` = " . $optional['disabled'] . " and ";
	else
		$where_str .= "`disabled` < " . TB_ROW_DEL_VALUE . " and ";
	
	if(format_and_push($data, 'upstartm', $optional, '', 'int', false))
		$where_str .= "`update_time` >= " . $optional['upstartm'] . " and ";

	if(format_and_push($data, 'endtm', $optional, '', 'int', false)) 
		$where_str .= "`update_time` < " . $optional['upendtm']  . " and ";

	if(format_and_push($data, 'startm', $optional, '', 'int', false))
		$where_str .= "`create_time` >= " . $optional['startm'] . " and ";

	if(format_and_push($data, 'endtm', $optional, '', 'int', false))
		$where_str .= "`create_time` < " . $optional['endtm']  . " and ";
*/
	// set custom options
	if(format_and_push($data, 'id', $optional, '', 'int', false))
		$where_str .= "b.`id` = " . $optional['id']  . " and ";

	if(format_and_push($data, 'serialno', $optional, 'license_id12', 'string', false)) {
		$where_str .= "b.`license_id12` = ? and ";
		array_push($values, $optional['license_id12']);
	}

	if(isset($data['tag'])) {
		$optional['tag'] = trim($data['tag']);
		$where_str .= "`tag` = ? and ";
		array_push($values, $optional['tag']);
	}

	if(isset($data['keyword'])) {
		if(format_and_push($data, 'keyword', $optional, '', 'string', false)) {
			$where_str .= "(b.`license_id12` like ? or b.`sysname` like ? or b.`tips` like ? or b.`myevent` like ?) and ";
			array_push($values, "%" . $optional['keyword'] . "%");
			array_push($values, "%" . $optional['keyword'] . "%");
			array_push($values, "%" . $optional['keyword'] . "%");
			array_push($values, "%" . $optional['keyword'] . "%");
		}
	}

	if($where_str != '')
		$where_str = substr("where $where_str", 0, -5);

	$order_map = array(
		"id",
		"myevent",
		"type",
		"openid",
		"license_id12",
		"tag",
		"status",
		"isupdate",
		"sysname",
		"tips",
	);

	$order = array();
	if(isset($optional['order'])) {
		foreach($optional['order'] as $op) {
			if(isset($op['column']) && isset($data['columns'][$op['column']]['data'])) {
				if(in_array($data['columns'][$op['column']]['data'], $order_map))
					array_push($order, "`" . $data['columns'][$op['column']]['data'] . "` " . $op['dir']);
			}
		}
	}

	if(count($order) > 0)
		$order_by = 'order by ' . implode(', ', $order);
	else
		$order_by = 'order by `id` desc';

	// $sql = "select count(*) as `total` from weixin_brokennet $where_str";

	$sql = "select count(*) as `total` from weixin_brokennet as `b`";
	$sql.= " inner join (select grpid,license_id12 from cloud_device";
	if(isset($optional['grpid']) && $optional['grpid'] != '')
		$sql.= " where grpid in ({$optional['grpid']})";
	$sql.= ") as `l` on l.`license_id12` = b.`license_id12` $where_str";

	try {
		$sth = $nidb->prepare($sql);
		$sth->execute($values);
		$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}
	
	if(count($rows) > 0) {
		$result = array(
			'total' => $rows[0]->total,
		);
	}
	else {
		$result = array(
			'total' => 0,
		);
	}

	if(isset($data['simplify'])) {
		$keys = '`myevent` as `event`,
			`type`,
			b.`license_id12` as `serialno`,
			`status`,
			`tag`,
			`sysname` as `name`,
			`tips`';
	}
	else{
		$keys = '`id`,
			`myevent` as `event`,
			`type`,
			`openid`,
			b.`license_id12` as `serialno`,
			`status`,
			`tag`,
			`old_status`,
			`sysname` as `name`,
			`tips`';
	}

	// $sql = "select $keys from weixin_brokennet $where_str $order_by limit ? offset ? ";

	$sql = "select {$keys} from weixin_brokennet as `b`";
	$sql.= " inner join (select grpid,license_id12 from cloud_device";
	if(isset($optional['grpid']) && $optional['grpid'] != '')
		$sql.= " where grpid in ({$optional['grpid']})";
	$sql.= ") as `l` on l.`license_id12` = b.`license_id12` $where_str limit ? offset ?";

	array_push($values, $optional['limit']);
	array_push($values, $optional['offset']);


	try {
		$sth = $nidb->prepare($sql);
		$sth->execute($values);
		$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

//	$result['page'] = intval($optional['offset'] / $optional['limit']);
	$result['limit'] = $optional['limit'];
	$result['rows'] = $rows;

	if(isset($data['draw'])) $result['draw'] = $data['draw'];

//	$result['sql'] = $sql;
	
//	$result['v'] = $values;

	return $result;
}

function select_tag($data)
{
	global $nidb, $user;
	
	
	$result = array(
		'page'	=> 0,
		'limit'	=> 0,
		'rows'	=> array()
	);
	
	$values = array();
	$optional = array();
	// set order, limit, offset value
	format_list_arg($data, $optional);

	format_and_push($data, 'grpid', $optional, '', 'int', false);

	// 设置用户组
	if(\cloud\apps\work\project\project_enable(array())) {
		$optional['grpid'] = \cloud\apps\work\project\in_work_grpidstr(1, $optional['grpid']);
		if($optional['grpid'] === false)
			return $result;
		if(empty($optional['grpid']) && !is_supadmin($user->username))
			return $result;
	}
	else {
		if (!is_supadmin($user->username)) {
			if($user->grp == '')
				return $result;
			if($optional['grpid'] <= 0)
				$optional['grpid'] = $user->grp;
			else {
				$grpids = explode(',', $user->grp);
				if(in_array($optional['grpid'], $grpids) == false) {
					return $result;
				}
			}
			if($optional['grpid'] == '')
				return $result;
		}
		else
		if($optional['grpid'] <= 0)
			$optional['grpid'] = '';
	}

	$where_str = '';

	// set custom options
	if(format_and_push($data, 'keyword', $optional, '', 'string', false)) {
		$where_str .= "b.`tag` = ? and ";
		array_push($values, "%" . $optional['keyword'] . "%");
	}

	if($where_str != '')
		$where_str = substr("where $where_str", 0, -5);

	$order_by = 'order by `tag` desc';

	$sql = "select count(*) as `total` from ";
	$sql.= "(select `tag` from weixin_brokennet as `b`";
	$sql.= " inner join (select grpid,license_id12 from cloud_device";
	if(isset($optional['grpid']) && $optional['grpid'] != '')
		$sql.= " where grpid in ({$optional['grpid']})";
	$sql.= ") as `l` on l.`license_id12` = b.`license_id12` $where_str group by `tag`) as `g`";

	try {
		$sth = $nidb->prepare($sql);
		$sth->execute($values);
		$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}
	
	if(count($rows) > 0) {
		$result = array(
			'total' => $rows[0]->total,
		);
	}
	else {
		$result = array(
			'total' => 0,
		);
	}

	$sql = "select `tag` from weixin_brokennet as `b`";
	$sql.= " inner join (select grpid,license_id12 from cloud_device";
	if(isset($optional['grpid']) && $optional['grpid'] != '')
		$sql.= " where grpid in ({$optional['grpid']})";
	$sql.= ") as `l` on l.`license_id12` = b.`license_id12` $where_str group by `tag` limit ? offset ?";

	array_push($values, $optional['limit']);
	array_push($values, $optional['offset']);


	try {
		$sth = $nidb->prepare($sql);
		$sth->execute($values);
		$rows = $sth->fetchAll(\PDO::FETCH_ASSOC);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

//	$result['page'] = intval($optional['offset'] / $optional['limit']);
	$result['limit'] = $optional['limit'];
	$result['rows'] = array();
	foreach($rows as $val) 
		array_push($result['rows'], $val['tag']);

	if(isset($data['draw'])) $result['draw'] = $data['draw'];

	return $result;
}

function add($data)
{
	global $nidb, $user;


	if($GLOBALS['global_MicroMessenger'] 
	&&(!isset($data['_token_']) || $data['_token_'] == '')) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '无效的操作！');
		return false;
	}

	$optional = array();
	
	// 设置用户组
	if(\cloud\apps\work\project\project_enable(array())) {
		$optional['grpid'] = \cloud\apps\work\project\in_work_grpidstr(1, $optional['grpid']);
		if($optional['grpid'] === false) {
			set_errmsg(MSG_LEVEL_ARG, __function__, "您的权限不足！1");
			return false;
		}
		if(empty($optional['grpid']) && !is_supadmin($user->username)) {
			set_errmsg(MSG_LEVEL_ARG, __function__, "您的权限不足！2");
			return false;
		}
	}
	else {
		if (!is_supadmin($user->username)) {
			if($user->grp == '') {
				set_errmsg(MSG_LEVEL_ARG, __function__, "您的权限不足！3");
				return false;
			}
			if($optional['grpid'] <= 0)
				$optional['grpid'] = $user->grp;
			else {
				$grpids = explode(',', $user->grp);
				if(in_array($optional['grpid'], $grpids) == false) {
					set_errmsg(MSG_LEVEL_ARG, __function__, "您的权限不足！");
					return false;
				}
			}
		}
		else 
		if($optional['grpid'] == 0)
			$optional['grpid'] = '10000,0';
		else 
		if($optional['grpid'] < 0)
			$optional['grpid'] = '';
	}

	$grpids = $optional['grpid'];
	$optional = array();
/*
	if(format_and_push($data, 'openid', $optional, '', 'string', false) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, 'openid不能为空。');
		return false;
	}

	if(preg_match("/^([a-zA-Z0-9-_]{20,})$/", $optional['openid'], $match) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, "OPENID“{$optional['openid']}”不正确！");
		return false;
	}
*/

	if(format_and_push($data, 'serialno', $optional, 'license_id12', 'string', false) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '12位编号不能为空。');
		return false;
	}
	if(preg_match("/^([a-zA-Z0-9-_]{12})$/", $optional['license_id12'], $match) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, "用户“{$optional['license_id12']}”不正确！");
		return false;
	}

	if(format_and_push($data, 'event', $optional, 'myevent', 'string', false) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '操作对象不能为空。');
		return false;
	}

	format_and_push($data, 'tag', $optional, '', 'string', true);
	format_and_push($data, 'tips', $optional, '', 'string', false);

	$sql = "select id from weixin_brokennet where `license_id12` = ? and `myevent` = ? limit 1";

	try {
		$sth = $nidb->prepare($sql);
		$sth->bindParam(1, $optional['license_id12'], \PDO::PARAM_STR);
		$sth->bindParam(2, $optional['myevent'], \PDO::PARAM_STR);
		$sth->execute($values);

		$row = $sth->fetch(\PDO::FETCH_LAZY);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	if($row) {
		set_errmsg(MSG_LEVEL_EXP, __function__, "“{$optional['myevent']}”对象已存在。");
		return false;
	}

	$sysname = "";
	if (!empty($optional['license_id12'])) {
		$cmd = DATAEYE . " device get license_id12={$optional['license_id12']} usergrp={$grpids}";
		exec($cmd, $out, $ret);
		$license_id12 = "";
		foreach($out as $val) {
			list($tag, $val) = explode('=', $val);
			if ($tag == "name") {
				$sysname = $val;
				$license_id12 = $optional['license_id12'];
			}
		}

		if ($sysname != "") {
			if (!is_utf8($sysname) || json_encode($sysname) == false)
				$sysname = iconv("gbk", "utf-8//translit", $sysname);
		}

		if($license_id12 != $optional['license_id12']) {
			set_errmsg(MSG_LEVEL_EXP, __function__, "“{$optional['license_id12']}”设备不存在。");
			return false;
		}
	}

	$optional['birth'] = time();
	// $optional['isupdate'] = 0;
	$optional['old_status'] = 1;
	$optional['status'] = 1;
	$optional['sysname'] = $sysname;

	// 检查是否域名
	if(is_ipstr($optional['myevent']) == 0)
		$optional['type'] = 1;

	try {
		if(insert_data('weixin_brokennet', $optional) === false) {
			$errmsg = implode(' ', $nidb->errorInfo());
			set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
			return false;
		}
		$optional['id'] = $nidb->lastInsertId();
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}
/*
	// 添加日志
	$logger = array(
		'type'		=> 0,
		'status'	=> 1,
		'avatarurl'	=> '',
		'device'	=> $optional['license_id12'],
		'openid'	=> '',
		'object'	=> $optional['myevent'],
		'username'	=> $user->username,
		'devname'	=> $sysname,
		'nickname'	=> ''
	);

	if($GLOBALS['global_MicroMessenger']) {
		// 小程序操作日志
		$wxuser = \cloud\apps\user\get_api_session_user($data['_token_']);
		if(is_object($wxuser)) { // 失败返回，false 则不记录
			$logger['avatarurl'] = $wxuser->img;
			$logger['nickname'] = $wxuser->nick;
			$logger['openid'] = $wxuser->openid;
			$logger['type'] = $wxuser->type;
		}
	}
	
	addlog($logger);
*/
	return $optional;
}

function save($data)
{
	global $nidb, $user;

	$where = array();
	$optional = array();
	
	if($GLOBALS['global_MicroMessenger'] 
	&&(!isset($data['_token_']) || $data['_token_'] == '')) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '无效的操作！');
		return false;
	}

	// 设置用户组
	if(\cloud\apps\work\project\project_enable(array())) {
		$optional['grpid'] = \cloud\apps\work\project\in_work_grpidstr(1, $optional['grpid']);
		if($optional['grpid'] === false) {
			set_errmsg(MSG_LEVEL_ARG, __function__, "您的权限不足！1");
			return false;
		}
		if(empty($optional['grpid']) && !is_supadmin($user->username)) {
			set_errmsg(MSG_LEVEL_ARG, __function__, "您的权限不足！2");
			return false;
		}
	}
	else {
		if (!is_supadmin($user->username)) {
			if($user->grp == '')
				return $result;
			if($optional['grpid'] <= 0)
				$optional['grpid'] = $user->grp;
			else {
				$grpids = explode(',', $user->grp);
				if(in_array($optional['grpid'], $grpids) == false) {
					set_errmsg(MSG_LEVEL_ARG, __function__, "您的权限不足！");
					return false;
				}
			}
		}
		else 
		if($optional['grpid'] == 0)
			$optional['grpid'] = '10000,0';
		else 
		if($optional['grpid'] < 0)
			$optional['grpid'] = '';
	}

	$grpids = $optional['grpid'];
	$optional = array();
/*
	if(format_and_push($data, 'openid', $optional, '', 'string', false) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, 'openid不能为空。');
		return false;
	}

	if(preg_match("/^([a-zA-Z0-9-_]{20,})$/", $optional['openid'], $match) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, "OPENID“{$optional['openid']}”不正确！");
		return false;
	}
*/
	if(format_and_push($data, 'id', $where, '', 'int', false) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '资源ID不能为空！');
		return false;
	}

	if(format_and_push($data, 'serialno', $optional, 'license_id12', 'string', false) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '12位编号不能为空。');
		return false;
	}
	if(preg_match("/^([a-zA-Z0-9-_]{12})$/", $optional['license_id12'], $match) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, "用户“{$optional['license_id12']}”不正确！");
		return false;
	}

	if(format_and_push($data, 'event', $optional, 'myevent', 'string', false) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '操作对象不能为空。');
		return false;
	}

	format_and_push($data, 'tag', $optional, '', 'string', true);
	format_and_push($data, 'tips', $optional, '', 'string', true);


	$sql = "select `id`,`myevent`,`old_status` from weixin_brokennet where `id` = ? limit 1";

	try {
		$sth = $nidb->prepare($sql);

		$sth->bindParam(1, $where['id'], \PDO::PARAM_STR);
		$sth->execute();

		$oldobj = $sth->fetch(\PDO::FETCH_LAZY);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	if(!$oldobj) {
		set_errmsg(MSG_LEVEL_EXP, __function__, "资源不存在。");
		return false;
	}

	$sql = "select `id` from weixin_brokennet where `id` != ? and `license_id12` = ? and `myevent` = ? limit 1";

	try {
		$sth = $nidb->prepare($sql);

		$sth->bindParam(1, $where['id'], \PDO::PARAM_STR);
		$sth->bindParam(2, $optional['license_id12'], \PDO::PARAM_STR);
		$sth->bindParam(3, $optional['myevent'], \PDO::PARAM_STR);
		$sth->execute($values);

		$row = $sth->fetch(\PDO::FETCH_LAZY);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	if($row) {
		set_errmsg(MSG_LEVEL_EXP, __function__, "新对象“{$optional['myevent']}”已存在。");
		return false;
	}

	$sysname = "";
	if (!empty($optional['license_id12'])) {
		$cmd = DATAEYE . " device get license_id12={$optional['license_id12']} usergrp={$grpids}";
		exec($cmd, $out, $ret);
		$not_exists = 1;
		foreach($out as $val) {
			list($tag, $val) = explode('=', $val);
			if ($tag == "name") {
				$sysname = $val;
				$not_exists = 0;
			}
		}

		if($not_exists) {
			set_errmsg(MSG_LEVEL_EXP, __function__, "“{$optional['license_id12']}”设备不存在。");
			return false;
		}

		if ($sysname != "") {
			if (!is_utf8($sysname) || json_encode($sysname) == false)
				$sysname = iconv("gbk", "utf-8//translit", $sysname);
		}
	}

	if($oldobj->old_status == 0 
	&& $oldobj->myevent != $optional['myevent']) {
		$optional['status'] = 1;
		$optional['isupdate'] = 1;
	}
	$optional['sysname'] = $sysname;

	try {
		if(update_data('weixin_brokennet', $optional, $where) === false) {
			$errmsg = implode(' ', $nidb->errorInfo());
			set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
			return false;
		}
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	if($oldobj->old_status == 0 
	&& $oldobj->myevent != $optional['myevent']) {
		// 添加日志
		$logger = array(
			'type'		=> 0,
			'status'	=> $optional['status'],
			'avatarurl'	=> '',
			'device'	=> $optional['license_id12'],
			'openid'	=> '',
			'object'	=> $optional['myevent'],
			'username'	=> $user->username,
			'devname'	=> $sysname,
			'nickname'	=> ''
		);

		if($GLOBALS['global_MicroMessenger']) {
			// 小程序操作日志
			$wxuser = \cloud\apps\user\get_api_session_user($data['_token_']);
			if(is_object($wxuser)) { // 失败返回，false 则不记录
				$logger['avatarurl'] = $wxuser->img;
				$logger['nickname'] = $wxuser->nick;
				$logger['openid'] = $wxuser->openid;
				$logger['type'] = $wxuser->type;
			}
		}
		
		addlog($logger);
	}

	return $optional;
}

function deny($data)
{
	global $nidb, $user;


	if($GLOBALS['global_MicroMessenger'] 
	&&(!isset($data['_token_']) || $data['_token_'] == '')) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '无效的操作！');
		return false;
	}

	$optional = array();
	// 设置用户组
	if(\cloud\apps\work\project\project_enable(array())) {
		$optional['grpid'] = \cloud\apps\work\project\in_work_grpidstr(1, $optional['grpid']);
		if($optional['grpid'] === false) {
			set_errmsg(MSG_LEVEL_ARG, __function__, "您的权限不足！1");
			return false;
		}
		if(empty($optional['grpid']) && !is_supadmin($user->username)) {
			set_errmsg(MSG_LEVEL_ARG, __function__, "您的权限不足！2");
			return false;
		}
	}
	else {
		if (!is_supadmin($user->username)) {
			if($user->grp == '')
				return $result;
			if($optional['grpid'] <= 0)
				$optional['grpid'] = $user->grp;
			else {
				$grpids = explode(',', $user->grp);
				if(in_array($optional['grpid'], $grpids) == false) {
					set_errmsg(MSG_LEVEL_ARG, __function__, "您的权限不足！");
					return false;
				}
			}
		}
		else 
		if($optional['grpid'] == 0)
			$optional['grpid'] = '10000,0';
		else 
		if($optional['grpid'] < 0)
			$optional['grpid'] = '';
	}
	
	$grpids = $optional['grpid'];
	$values = array();


	if(isset($data['allow']) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '操作方法不能为空。');
		return false;
	}
	$allow = intval($data['allow']);

	// 不为 0 则发送微信消息
	if(isset($data['wxmsg']) && intval($data['wxmsg']))
		$isupdate = 127;
	else
		$isupdate = 1;

	if(isset($data['ids']) == false) {

		if(add($data) === false)
			set_errmsg(MSG_LEVEL_ARG, __function__, '');
//			return false;

		if(format_and_push($data, 'serialno', $values, 'license_id12', 'string', false) == false) {
			set_errmsg(MSG_LEVEL_ARG, __function__, '12位编号不能为空。');
			return false;
		}
		if(preg_match("/^([a-zA-Z0-9-_]{12})$/", $values['license_id12'], $match) == false) {
			set_errmsg(MSG_LEVEL_ARG, __function__, "用户“{$values['license_id12']}”不正确！");
			return false;
		}

		if(format_and_push($data, 'event', $values, 'myevent', 'string', false) == false) {
			set_errmsg(MSG_LEVEL_ARG, __function__, '操作对象不能为空。');
			return false;
		}

		// 获取设备名称
		$cmd = DATAEYE . " device get license_id12={$values['license_id12']} usergrp={$grpids}";
		exec($cmd, $out, $ret);
		$sysname = '';
		$not_exists = 1;
		foreach($out as $val) {
			list($tag, $val) = explode('=', $val);
			if ($tag == "name") {
				$sysname = $val;
				$not_exists = 0;
			}
		}

		if($not_exists) {
			set_errmsg(MSG_LEVEL_EXP, __function__, "“{$optional['license_id12']}”设备不存在。");
			return false;
		}
		
		if ($sysname != "") {
			if (!is_utf8($sysname) || json_encode($sysname) == false)
				$sysname = iconv("gbk", "utf-8//translit", $sysname);
		}

		$sql = "update weixin_brokennet set `status` = {$allow}, `isupdate` = {$isupdate}";
		if($sysname != '')
			$sql.= ", `sysname` = ?";
		$sql.= " where `license_id12` = ? and `myevent` = ? ";

		try {
			$sth = $nidb->prepare($sql);
			if($sysname != '') {
				$sth->bindParam(1, $sysname, \PDO::PARAM_STR);
				$sth->bindParam(2, $values['license_id12'], \PDO::PARAM_STR);
				$sth->bindParam(3, $values['myevent'], \PDO::PARAM_STR);
			}
			else {
				$sth->bindParam(1, $values['license_id12'], \PDO::PARAM_STR);
				$sth->bindParam(2, $values['myevent'], \PDO::PARAM_STR);
			}

			$ret = $sth->execute();
		}
		catch (\NiDBException $e) {
			set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
			return false;
		}

		if($ret == false) 
			return false;

		$rowCount = $sth->rowCount();

		$logger = array(
			'type'		=> 0,
			'status'	=> $allow,
			'avatarurl'	=> '',
			'device'	=> $values['license_id12'],
			'openid'	=> '',
			'object'	=> $values['myevent'],
			'username'	=> $user->username,
			'devname'	=> $sysname,
			'nickname'	=> ''
		);

		if($GLOBALS['global_MicroMessenger']) {
			// 小程序操作操作日志
			$wxuser = \cloud\apps\user\get_api_session_user($data['_token_']);
			if(is_object($wxuser)) {// 失败返回，false 则不记录
				$logger['avatarurl'] = $wxuser->img;
				$logger['nickname'] = $wxuser->nick;
				$logger['openid'] = $wxuser->openid;
				$logger['type'] = $wxuser->type;
			}
		}

		addlog($logger);
	}
	else {
		if(is_array($data['ids']) == false)
			$data['ids'] = explode(',', $data['ids']);

		foreach($data['ids'] as $val) {
			$id = intval($val);
			if($id <= 0){
				set_errmsg(MSG_LEVEL_ARG, __function__, "删除对象“{$id}”不正确。");
				return false;
			}
			array_push($values, $id);
		}

		if(count($values) == 0) {
			set_errmsg(MSG_LEVEL_ARG, __function__, '删除对象不能为空。');
			return false;
		}

		$idstr = '?';
		if(count($values) > 1)
			$idstr .= str_repeat(',?' , count($values) - 1);

		$sql = "update weixin_brokennet set `status` = ${allow}, `isupdate` = {$isupdate} where `id` in($idstr)";

		try {
			$sth = $nidb->prepare($sql);
			$ret = $sth->execute($values);
		}
		catch (\NiDBException $e) {
			set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
			return false;
		}

		if($ret == false) 
			return false;

		$rowCount = $sth->rowCount();


		// 添加日志
		$sql = "select `license_id12`, `myevent`, `sysname` from weixin_brokennet where `id` in($idstr)";

		try {
			$sth = $nidb->prepare($sql);
			$ret = $sth->execute($values);
			$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
		}
		catch (\NiDBException $e) {
			set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
			return false;
		}

		if($rows) {
			$logger = array(
				'type'		=> 0,
				'status'	=> $allow,
				'avatarurl'	=> '',
				'device'	=> '',
				'openid'	=> '',
				'object'	=> '',
				'username'	=> $user->username,
				'devname'	=> '',
				'nickname'	=> ''
			);
			if($GLOBALS['global_MicroMessenger']) {
				// 小程序操作日志
				$wxuser = \cloud\apps\user\get_api_session_user($data['_token_']);
				if(is_object($wxuser)) {// 失败返回，false 则不记录
					$logger['avatarurl'] = $wxuser->img;
					$logger['nickname'] = $wxuser->nick;
					$logger['openid'] = $wxuser->openid;
					$logger['type'] = $wxuser->type;
				}
			}
			foreach($rows as $row) {
				$logger['device'] = $row->license_id12;
				$logger['object'] = $row->myevent;
				// $data['sysname'] = $row->license_id12;

				$logger['devname'] = $row->sysname;
				addlog($logger);
			}
		}
	}
	
	return $rowCount;
}

function addlog($data)
{
	global $nidb;
	

	$optional = array();
	if(isset($data['status']) == false) {
		return false;
	}
	if(format_and_push($data, 'device', $optional, '', 'string', false) == false) {
		return false;
	}
	if(format_and_push($data, 'object', $optional, '', 'string', false) == false) {
		return false;
	}
	if(format_and_push($data, 'username', $optional, '', 'string', false) == false) {
		return false;
	}

	format_and_push($data, 'type', $optional, '', 'int', true);
	format_and_push($data, 'avatarurl', $optional, '', 'string', false);
	format_and_push($data, 'openid', $optional, '', 'string', false);
	format_and_push($data, 'nickname', $optional, '', 'string', false);
	format_and_push($data, 'devname', $optional, '', 'string', false);

	if(isset($optional['avatarurl']))
		$optional['avatarurl'] = urldecode($optional['avatarurl']);

	if(isset($optional['nickname']))
		$optional['nickname'] = urldecode($optional['nickname']);

	$optional['status'] = $data['status'];
	$optional['birth'] = time();
	$optional['ipaddr'] = get_real_ip();

	try {
		if(insert_data('weixin_brokennet_operation', $optional) === false) {
			return false;
		}
		$optional['id'] = $nidb->lastInsertId();
	}
	catch (\NiDBException $e) {
		return false;
	}

	return $optional;
}

function remove($data)
{
	global $nidb, $user;

	$values = array();
	
	if($GLOBALS['global_MicroMessenger'] 
	&&(!isset($data['_token_']) || ($data['_token_'] = trim($data['_token_'])) == '')) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '无效的操作！');
		return false;
	}

	$devkeys = array();
	if(isset($data['ids']) == false) {
		if(format_and_push($data, 'serialno', $values, 'license_id12', 'string', false) == false) {
			set_errmsg(MSG_LEVEL_ARG, __function__, '12位编号不能为空。');
			return false;
		}
		if(preg_match("/^([a-zA-Z0-9-_]{12})$/", $values['license_id12'], $match) == false) {
			set_errmsg(MSG_LEVEL_ARG, __function__, "用户“{$values['license_id12']}”不正确！");
			return false;
		}

		if(format_and_push($data, 'event', $values, 'myevent', 'string', false) == false) {
			set_errmsg(MSG_LEVEL_ARG, __function__, '操作对象不能为空。');
			return false;
		}

		$sysname = '';
		$sql = "select `sysname` from weixin_brokennet where where `license_id12` = ? and `myevent` = ?";
		try {
			$sth = $nidb->prepare($sql);
			$sth->bindParam(1, $values['license_id12'], \PDO::PARAM_STR);
			$sth->bindParam(2, $values['myevent'], \PDO::PARAM_STR);
			$ret = $sth->execute();

			while ($row = $sth->fetch(\PDO::FETCH_ASSOC, \PDO::FETCH_ORI_NEXT)) {
				$sysname = $row['sysname'];
				break;
			}
		}
		catch (\NiDBException $e) {
			set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
			return false;
		}

		$sql = "delete from weixin_brokennet where `license_id12` = ? and `myevent` = ? ";
		
		try {
			$sth = $nidb->prepare($sql);
			$sth->bindParam(1, $values['license_id12'], \PDO::PARAM_STR);
			$sth->bindParam(2, $values['myevent'], \PDO::PARAM_STR);
			$ret = $sth->execute();
		}
		catch (\NiDBException $e) {
			set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
			return false;
		}

		$logger = array(
			'type'		=> 0,
			'status'	=> 1,
			'avatarurl'	=> '',
			'device'	=> $values['license_id12'],
			'openid'	=> '',
			'object'	=> $values['myevent'],
			'username'	=> $user->username,
			'devname'	=> $sysname,
			'nickname'	=> ''
		);

		if($GLOBALS['global_MicroMessenger']) {
			// 小程序操作日志
			$wxuser = \cloud\apps\user\get_api_session_user($data['_token_']);
			if(is_object($wxuser)) {
				// 失败返回，false 则不记录
				$logger['avatarurl'] = $wxuser->img;
				$logger['nickname'] = $wxuser->nick;
				$logger['openid'] = $wxuser->openid;
				$logger['type'] = $wxuser->type;
			}
		}

		addlog($logger);

		array_push($devkeys, $logger['device']);
	}
	else {
		if(is_array($data['ids']) == false)
			$data['ids'] = explode(',', $data['ids']);

		foreach($data['ids'] as $val) {
			$id = intval($val);
			if($id <= 0){
				set_errmsg(MSG_LEVEL_ARG, __function__, "删除对象“{$id}”不正确。");
				return false;
			}
			array_push($values, $id);
		}

		if(count($values) == 0) {
			set_errmsg(MSG_LEVEL_ARG, __function__, '删除对象不能为空。');
			return false;
		}
		
		$idstr = '?';
		if(count($values) > 1)
			$idstr .= str_repeat(',?' , count($values) - 1);

		$logger = array (
			'type'		=> 0,
			'status'	=> 1,
			'avatarurl'	=> '',
			'serialno'	=> '',
			'openid'	=> '',
			'object'	=> '',
			'username'	=> $user->username,
			'devname'	=> '',
			'nickname'	=> ''
		);
		if($GLOBALS['global_MicroMessenger']) {
			// 小程序操作删除日志
			$wxuser = \cloud\apps\user\get_api_session_user($data['_token_']);
			if(is_object($wxuser)) {// 失败返回，false 则不记录
				$logger['nickname'] = $wxuser->nick;
				$logger['avatarurl'] = $wxuser->img;
				$logger['openid'] = $wxuser->openid;
				$logger['type'] = $wxuser->type;
			}
		}

		$sql = "select `myevent`, `sysname`, `license_id12` from weixin_brokennet where `id` in($idstr)";
		try {
			$sth = $nidb->prepare($sql);
			$ret = $sth->execute($values);

			// 操作日志
			while ($row = $sth->fetch(\PDO::FETCH_ASSOC, \PDO::FETCH_ORI_NEXT)) {
				$logger['object'] = $row['myevent'];
				$logger['device'] = $row['license_id12'];
				$logger['devname'] = $row['sysname'];
				addlog($logger);
				
				array_push($devkeys, $logger['device']);
			}
		}
		catch (\NiDBException $e) {
			set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
			return false;
		}

		$sql = "delete from weixin_brokennet where `id` in($idstr)";

		try {
			$sth = $nidb->prepare($sql);
			$ret = $sth->execute($values);
		}
		catch (\NiDBException $e) {
			set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
			return false;
		}
	}
	
	$dir = LOGDATA_DIR . '/weixin';
	if(!is_dir($dir)) {
		exec("mkdir -p {$dir} > /dev/null 2>&1", $out, $ret);
		unset($out);
	}

	$fp = fopen("{$dir}/delete_keyno.lst", 'a');
	if($fp) {
		foreach($devkeys as $keyno) {
			fwrite($fp, "{$keyno}\n");
		}
		fclose($fp);
	}
	
	if($ret == false) 
		return false;

	return true;
}

function clean($data)
{
	global $nidb;


	$ids = array();
	$sync = 0;
	if(isset($data['sync']))
		$sync = intval($data['sync']);
	if($sync) {
		if(is_string($data['ids'])) {
			$ids = explode(',', $data['ids']);
			foreach($ids as $key => $val) {
				$ids[$key] = intval($val);
			}
		}
		else
		if(is_array($data['ids']))
			$ids = $data['ids'];
	}

	if(isset($data['dev']) == false || empty($data['dev'])) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '要清空的设备不能为空。');
		return false;
	}
	
	if(is_string($data['dev']))
		$devs = explode(',', $data['dev']);
	else
	if(is_array($data['dev']))
		$devs = $data['dev'];
	else {
		set_errmsg(MSG_LEVEL_ARG, __function__, '指定要清空的设备不正确。');
		return false;
	}
	
	$values = array();
	$count = 0;
	foreach($devs as $dev) {
		if(preg_match("/^([a-zA-Z0-9-_]{12})$/", $dev, $match) == false) {
			set_errmsg(MSG_LEVEL_ARG, __function__, '指定要清空的设备编号不正确。');
			return false;
		}
		array_push($values, $dev);
	}

	$idstr = '?';
	if(count($values) > 1)
		$idstr .= str_repeat(',?' , count($values) - 1);

	$sql = "delete from weixin_brokennet where `license_id12` in($idstr)";

	try {
		$sth = $nidb->prepare($sql);
		$ret = $sth->execute($values);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}
	
	if($sync && count($ids) > 0 && count($ids) <= count($values)) {
		if(!is_dir(API_WXDENY_DIR))
			mkdir(API_WXDENY_DIR);
		foreach($ids as $index => $devid) {
			if($devid < 0 || $devid > 65535)
				continue;

			$content = "devid={$devid}";
			file_put_contents(API_WXDENY_DIR . "/{$values[$index]}", $content);
		}
	}

	return true;
}

function upload($data)
{
	global $nidb, $user;

	$optional = array();

	if(\cloud\apps\work\project\project_enable(array())) {
		if(!\cloud\apps\work\project\in_work_project(ROLE_TECHN)) {
			set_errmsg(MSG_LEVEL_ARG, __function__, '您的权限不足！');
			return false;
		}
	}
	else
	if(!is_supadmin($user->username)) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '您的权限不足。');
		return false;
	}

	$upfile = $_FILES['file'];
	if (isset($upfile['name']) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '导入失败！');
		return false;
	}

	$upname = strtolower($upfile['name']);
	if (strpos($upname, ".php") !== false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '无效的导入文件！');
		return false;
	}
	if (substr($upname, -4) == ".lst") 
		$ftype = 1;
	else
		$ftype = 0;

	$target = "/tmp/netoff_object";
	if (file_exists($target)) 
		unlink($target);

	if (!move_uploaded_file($upfile['tmp_name'], $target)) {
		unlink($upfile['tmp_name']);
		set_errmsg(MSG_LEVEL_ARG, __function__, '文件导入失败！');
		return false;
	}
	if(isset($optional['cover']))
		$cover = intval($optional['cover']);
	else
		$cover = 0;
		
	$fp = fopen($target, 'r');
	if(!$fp) {
		unlink($target);
		set_errmsg(MSG_LEVEL_ARG, __function__, '打开文件导入失败！');
		return false;
	}
	
	$optional = array(
		'birth'	=> time()
	);
	$dupdate = array(
		'birth'	=> time()
	);
	while (!feof($fp)) {
		if(($buf = fgets($fp)) === false)
			break;
		if(empty($buf = trim($buf, "\t\n\r\0\x0B")))
			continue;

		$col = explode(' ', $buf);
		if(count($col) < 3)
			continue;
		
		$fdata = array();
		foreach($col as $val) {
			if($val != '')
				array_push($fdata, $val);
		}
		if(count($fdata) < 3)
			continue;
		
		$tag = '';
		$status = ($fdata[0] == 'allow'?1:0);
		$serialno = $fdata[1];
		$myevent = $fdata[2];
		if($ftype) {
			if(count($fdata) > 3) {
				$tag = $fdata[3];
				if($tag == 'NULL')
					$tag = '';
				if(count($fdata) > 4)
					$tips = $fdata[4];
				else
					$tips = '';
			}
			else {
				$tag = '';
				$tips = '';
			}

		} else {
			if(count($fdata) > 3)
				$tips = $fdata[3];
			else
				$tips = '';
		}

		if(preg_match("/^([a-zA-Z0-9-_]{12})$/", $serialno, $match) == false){
			set_errmsg(MSG_LEVEL_EXP, __function__, "“{$serialno}”编号格式不正确。");
			return false;
		}
		
		$cmd = DATAEYE . " device get license_id12={$serialno}";
		exec($cmd, $out, $ret);
		$sysname = '';
		foreach($out as $val) {
			list($key, $val) = explode('=', $val);
			if ($key == "name") {
				$sysname = $val;
			}
		}
		unset($out);

		if ($sysname != "") {
			if (!is_utf8($sysname) || json_encode($sysname) == false)
				$sysname = iconv("gbk", "utf-8//translit", $sysname);
		}

		if($serialno != $serialno) {
			set_errmsg(MSG_LEVEL_EXP, __function__, "“{$serialno}”设备不存在。");
			return false;
		}

		$sql = "select `status` from weixin_brokennet";
		$sql.= " where `license_id12` = '{$serialno}' and `myevent` = ? ";
		try {
			$sth = $nidb->prepare($sql);
			$sth->bindParam(1, $myevent, \PDO::PARAM_STR);
			$sth->execute($values);
			$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
		}
		catch (\NiDBException $e) {
			set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
			return false;
		}
		
		if(count($rows) > 0) {
			if($cover) {
				$dupdate['status'] = $status;
				$dupdate['sysname'] = $sysname;
				if(!empty($tips))
					$dupdate['tips'] = $tips;

				$where = array(
					'myevent'	=> $myevent,
					'license_id12'	=> $serialno
				);
				try {
					if(update_data('weixin_brokennet', $dupdate, $where) === false) {
						$errmsg = implode(' ', $nidb->errorInfo());
						set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
						return false;
					}
				}
				catch (\NiDBException $e) {
					set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
					return false;
				}
			}
			continue;
		}

		$optional['myevent'] = $myevent;
		$optional['license_id12'] = $serialno;
		$optional['status'] = $status;
		$optional['old_status'] = $status?0:$status;
		$optional['sysname'] = $sysname;
		$optional['tips'] = $tips;
		$optional['tag'] = $tag;

		try {
			if(insert_data('weixin_brokennet', $optional) === false) {
				$errmsg = implode(' ', $nidb->errorInfo());
				set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
				return false;
			}
		}
		catch (\NiDBException $e) {
			set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
			return false;
		}
	}
	fclose($fp);

	return true;
}

function export($data)
{
	global $nidb, $user;


	$optional = array();

	if(\cloud\apps\work\project\project_enable(array())) {
		if(!\cloud\apps\work\project\in_work_project(ROLE_TECHN)) {
			set_errmsg(MSG_LEVEL_ARG, __function__, '您的权限不足！');
			return false;
		}
	}
	else
	if(!is_supadmin($user->username)) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '您的权限不足。');
		return false;
	}

	$where_str = '';
	$values = array();
	if(isset($data['keyword'])) {
		if(format_and_push($data, 'keyword', $optional, '', 'string', false)) {
			$where_str .= "(`license_id12` like ? or `sysname` like ? or `tips` like ? or `myevent` like ?) and ";
			array_push($values, "%" . $optional['keyword'] . "%");
			array_push($values, "%" . $optional['keyword'] . "%");
			array_push($values, "%" . $optional['keyword'] . "%");
			array_push($values, "%" . $optional['keyword'] . "%");
		}
	}

	if($where_str != '')
		$where_str = substr("where $where_str", 0, -5);

	$keys = "concat_ws(' ', if(`status` = 0, 'deny', 'allow'), `license_id12`, `myevent`) as `value`, `tag`, `tips`";
	$sql = "select {$keys} from weixin_brokennet {$where_str} order by `id` desc";
	try {
		$sth = $nidb->prepare($sql);
		$sth->execute($values);
		$rows = $sth->fetchAll(\PDO::FETCH_ASSOC);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}
	
	$txt = '';
	foreach($rows as $row) {
		$tag = $row['tag'];
		if($row['tag'] == '')
			$tag = 'NULL';
		$txt.= "{$row['value']} {$tag} {$row['tips']}\n";
	}
	return $txt;
}
