<?php
namespace cloud\apps\sac\allowmac;


function select($data)
{
	global $user;

	$optional = array();
	$result = array(
		'rows'		=> array(),
		'total'		=> 0,
	);

	$now = strtotime("now");
	$result['now'] = $now;

	// set custom options
	if(format_and_push($data, 'apmac', $optional, '', 'string', false) == false)
		$optional['apmac'] = "";

	format_and_push($data, 'keyword', $optional, '', 'string', true);

	
	// 设置用户组
	if(format_and_push($data, 'grpid', $optional, '', 'int', false) == false)
		$optional['grpid'] = -1;
	
	
	if(\cloud\apps\work\project\project_enable(array())) {
		$optional['grpid'] = \cloud\apps\work\project\in_work_grpidstr(4, $optional['grpid']);
		if($optional['grpid'] === false)
			return $result;
		if(empty($optional['grpid']) && !is_supadmin($user->username))
			return $result;
	}
	else {
		if(!is_supadmin($user->username)) {
			if($user->grp == '')
				return $result;
			if($optional['grpid'] == -1)
				$optional['grpid'] = $user->grp;
			else {
				$grpids = explode(',', $user->grp);
				if(in_array($optional['grpid'], $grpids) == false) {
					return $result;
				}
			}
		}
	}

	foreach($optional as $key => $val) {
		if(gettype($val) == 'string')
			$optional[$key] = shell_filter($val);
	}

	$cmd = SACEYE . " allowmac list apmac={$optional['apmac']}";
	$cmd.= " grpid={$optional['grpid']} name={$optional['keyword']}";

	$page_arg = get_query_page($data);
	$cmd.= " page={$page_arg['page']} limit={$page_arg['limit']}";
	$cmd.= " sort={$page_arg['sort']} sortdesc={$page_arg['sortdesc']}";

	exec($cmd, $out, $ret);

	return implode('', $out);
//	$result['rows'] = implode('', $out);

//	return $result;
}

function add($data)
{
	global $user;
	
	$optional = array();
	$result = array();

	// set custom options
	if(format_and_push($data, 'apmac', $optional, '', 'string', false) == false) {
		set_errmsg(MSG_LEVEL_DEF, __function__, 'AP设备的MAC地址不能为空！');
		return false;
	}
	if(format_and_push($data, 'mac', $optional, '', 'string', false) == false) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '白名MAC地址不能为空！');
		return false;
	}
	format_and_push($data, 'remark', $optional, '', 'string', true);

	foreach($optional as $key => $val) {
		if(gettype($val) == 'string')
			$optional[$key] = shell_filter($val);
	}

	$cmd = SACEYE . " allowmac add";
	$cmd.= " apmac={$optional['apmac']} mac={$optional['mac']} remark={$optional['remark']}";
	
	exec($cmd, $out, $ret);

	$error = trim(implode(' ', $out), " \n\r");

	if($error != '') {
		set_errmsg(MSG_LEVEL_DEF, __function__, $error);
		return false;
	}

	return true;
}

function remove($data)
{
	global $user;
	
	$optional = array();
	$result = array();

	// set custom options
	if(format_and_push($data, 'apmac', $optional, '', 'string', false) == false) {
		set_errmsg(MSG_LEVEL_DEF, __function__, 'AP设备的MAC地址不能为空！');
		return false;
	}
	if(format_and_push($data, 'mac', $optional, '', 'string', false) == false) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '白名MAC地址不能为空！');
		return false;
	}

	foreach($optional as $key => $val) {
		if(gettype($val) == 'string')
			$optional[$key] = shell_filter($val);
	}
	
	$cmd = SACEYE . " allowmac remove apmac={$optional['apmac']} mac={$optional['mac']}";
	exec($cmd, $out, $ret);

	$error = trim(implode(' ', $out), " \n\r");
	if($error != '') {
		set_errmsg(MSG_LEVEL_DEF, __function__, $error);
		return false;
	}

	return true;
}

function enable($data)
{
	global $user;
	
	$optional = array();
	$result = array();

	// set custom options
	if(format_and_push($data, 'apmac', $optional, '', 'string', false) == false) {
		set_errmsg(MSG_LEVEL_DEF, __function__, 'AP设备的MAC地址不能为空！');
		return false;
	}
	if(format_and_push($data, 'enable', $optional, '', 'int', false) == false) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '开关状态值不能为空！');
		return false;
	}

	foreach($optional as $key => $val) {
		if(gettype($val) == 'string')
			$optional[$key] = shell_filter($val);
	}
	
	$cmd = SACEYE . " allowmac add apmac={$optional['apmac']} enable={$optional['enable']}";
	exec($cmd, $out, $ret);

	$error = trim(implode(' ', $out), " \n\r");
	if($error != '') {
		set_errmsg(MSG_LEVEL_DEF, __function__, $error);
		return false;
	}

	return true;
}