<?php
namespace cloud\apps\sac\aptask;


function select($data)
{
	global $user;

	$optional = array();
	$result = array(
		'rows'		=> array(),
		'total'		=> 0,
	);

	$now = strtotime("now");
	$result['now'] = $now;

	// set custom options
	format_and_push($data, 'db_idx', $optional, '', 'int', false);
	format_and_push($data, 'idx', $optional, '', 'int', false);
	format_and_push($data, 'keyword', $optional, '', 'string', true);
	format_and_push($data, 'show', $optional, '', 'string', true);
	format_and_push($data, 'type', $optional, '', 'string', true);

	if(format_and_push($data, 'db_type', $optional, '', 'int', false) == false) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '数据类型不正确！');
		return false;
	}

	// 设置用户组
	if(format_and_push($data, 'grpid', $optional, '', 'int', false) == false)
		$optional['grpid'] = -1;
	
	
	if(\cloud\apps\work\project\project_enable(array())) {
		$optional['grpid'] = \cloud\apps\work\project\in_work_grpidstr(4, $optional['grpid']);
		if($optional['grpid'] === false)
			return $result;
		if(empty($optional['grpid']) && !is_supadmin($user->username))
			return $result;
	}
	else {
		if(!is_supadmin($user->username)) {
			if($user->grp == '')
				return $result;
			if($optional['grpid'] == -1)
				$optional['grpid'] = $user->grp;
			else {
				$grpids = explode(',', $user->grp);
				if(in_array($optional['grpid'], $grpids) == false) {
					return $result;
				}
			}
		}
	}

	foreach($optional as $key => $val) {
		if(gettype($val) == 'string')
			$optional[$key] = shell_filter($val);
	}

	$cmd = SACEYE . " aptask list idx={$optional['idx']} type={$optional['type']}";
	$cmd.= " grpid={$optional['grpid']} show={$optional['show']}";
	$cmd.= " db_type={$optional['db_type']} db_idx={$optional['db_idx']}";

	$page_arg = get_query_page($data);
	$cmd.= " page={$page_arg['page']} limit={$page_arg['limit']}";
	$cmd.= " sort={$page_arg['sort']} sortdesc={$page_arg['sortdesc']}";

	exec($cmd, $out, $ret);

	return implode('', $out);
//	$result['rows'] = implode('', $out);

//	return $result;
}

function add($data)
{
	global $user;
	
	$optional = array();

	// set custom options
	if(format_and_push($data, 'apids', $optional, '', 'string', false) == false) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '要加入的AP不能为空！');
		return false;
	}
	if(!isset($data['db_idx']) || ($optional['db_idx'] = intval($data['db_idx'])) < 0) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '指定的数据源IDX无效！');
		return false;
	}
	
	if(format_and_push($data, 'db_type', $optional, '', 'int', false) == false) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '数据类型不能正确！');
		return false;
	}

	foreach($optional as $key => $val) {
		if(gettype($val) == 'string')
			$optional[$key] = shell_filter($val);
	}

	$errcnt = 0;
	$errmsg = '';
	$apids = explode(',', $optional['apids']);
	foreach($apids as $id) {
		
		$id = intval($id);
		$cmd = SACEYE . " aptask add enable=0";
		$cmd.= " db_type={$optional['db_type']} db_idx={$optional['db_idx']} ";
		$cmd.= " ap_idx={$id}";

		exec($cmd, $out, $ret);
		$error = trim(implode(' ', $out), " \n\r");
		if($error != '') {
			$errcnt++;
			$errmsg = $error;
		}

		unset($out);
	}
	
	if($errcnt) {
		set_errmsg(MSG_LEVEL_DEF, __function__, "有 {$errcnt} 项添加失败！{$errmsg}");
		return false;
	}

	return true;
}

function save($data)
{
	global $user;
	
	$optional = array(
		'svrip' => '',
		'svrdomain' => '',
	);

	// set custom options
	if(!isset($data['id']) || ($optional['id'] = intval($data['id'])) < 0) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '指定的iWAN无效！');
		return false;
	}
	
	if(format_and_push($data, 'user', $optional, '', 'string', false) == false) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '帐号不能为空！');
		return false;
	}
	if(format_and_push($data, 'svrhost', $optional, '', 'string', false) == false) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '服务主机不能为空！');
		return false;
	}
	if(is_ipaddr($optional['svrhost']))
		$optional['svrip'] = $optional['svrhost'];
	else
		$optional['svrdomain'] = $optional['svrhost'];

	if(format_and_push($data, 'svrport', $optional, '', 'int', false) == false) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '端口不正确！');
		return false;
	}
	if($optional['svrport'] < 0 || $optional['svrport'] > 65535) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '端口不正确！');
		return false;
	}

	if(!isset($data['type']) || ($optional['type'] = intval($data['type'])) < 0
	|| $optional['type'] > 1) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '指定的类型无效！');
		return false;
	}

	format_and_push($data, 'pass', $optional, '', 'string', true);

	if($optional['type'] == 0) {
		
		if(format_and_push($data, 'ssid', $optional, '', 'string', false) == false) {
			set_errmsg(MSG_LEVEL_DEF, __function__, 'iWAN-SSID不能为空！');
			return false;
		}

		format_and_push($data, 'encrypt', $optional, '', 'int', false);
		
		format_and_push($data, 'pass', $optional, '', 'string', true);

		foreach($optional as $key => $val) {
			if(gettype($val) == 'string')
				$optional[$key] = shell_filter($val);
		}

		$cmd = SACEYE . " iwanpool set idx={$optional['id']}";
		$cmd.= " user={$optional['user']} pass={$optional['pass']} type={$optional['type']}";
		$cmd.= " encrypt={$optional['encrypt']} svrip={$optional['svrip']}";
		$cmd.= " svrdomain={$optional['svrdomain']} svrport={$optional['svrport']}";
		$cmd.= " ssid={$optional['ssid']}";

	}
	else 
	{
		if(format_and_push($data, 'proto', $optional, '', 'int', false) == false) 
			$optional['proto'] = 0;

		if(format_and_push($data, 'ifname', $optional, '', 'string', false) == false) {
			set_errmsg(MSG_LEVEL_DEF, __function__, '有线口不能为空！');
			return false;
		} 

		if(format_and_push($data, 'sport', $optional, '', 'int', false) == false)
			$optional['sport'] = 0;
		if($optional['sport'] < 0 || $optional['sport'] > 65535) {
			set_errmsg(MSG_LEVEL_DEF, __function__, '端口不正确！');
			return false;
		}

		if(format_and_push($data, 'dport', $optional, '', 'int', false) == false)
			$optional['dport'] = 0;
		if($optional['dport'] < 0 || $optional['dport'] > 65535) {
			set_errmsg(MSG_LEVEL_DEF, __function__, '端口不正确！');
			return false;
		}

		format_and_push($data, 'srcnet', $optional, '', 'string', false);
		format_and_push($data, 'dstnet', $optional, '', 'string', false);

		foreach($optional as $key => $val) {
			if(gettype($val) == 'string')
				$optional[$key] = shell_filter($val);
		}

		// pappiw routeifadd idx= ? src=有线口 proto=tcp/udp/all  sport=443 dport=8065 snet=10.10.0.1/24 dnet=10.20.10.1/24
		$cmd = SACEYE . " iwanpool set idx={$optional['id']} svrport={$optional['svrport']}";
		$cmd.= " svrip={$optional['svrip']} svrdomain={$optional['svrdomain']}";
		$cmd.= " user={$optional['user']} pass={$optional['pass']} type={$optional['type']}";
		$cmd.= " ifname={$optional['ifname']} proto={$optional['proto']} sport={$optional['sport']}";
		$cmd.= " dport={$optional['dport']} srcnet={$optional['srcnet']} dstnet={$optional['dstnet']}";
	}

	exec($cmd, $out, $ret);

	$error = trim(implode(' ', $out), " \n\r");

	if($error != '') {
		set_errmsg(MSG_LEVEL_DEF, __function__, $error);
		return false;
	}

	return true;
}

function remove($data)
{
	global $user;
	
	$optional = array();
	$result = array();

	// set custom options
	if(!isset($data['task_id']) || ($optional['task_id'] = intval($data['task_id'])) < 0) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '指定的iWAN无效！');
		return false;
	}

	foreach($optional as $key => $val) {
		if(gettype($val) == 'string')
			$optional[$key] = shell_filter($val);
	}
	
	$cmd = SACEYE . " aptask remove idx={$optional['task_id']}";
	exec($cmd, $out, $ret);

	$error = trim(implode(' ', $out), " \n\r");
	if($error != '') {
		set_errmsg(MSG_LEVEL_DEF, __function__, $error);
		return false;
	}

	return true;
}
