<?php
namespace cloud\apps\user;

require_once(ROOT_DIR . '/conf/db.php');
require_once(__DIR__ . '/user.php');

ni_app_load('work', 'project');
// ********************************************************
// session of manage
// ********************************************************
$GLOBALS['global_session_start'] = 0;
$GLOBALS['global_MicroMessenger'] = 0; // 小否小程序请求

function session_init($name = '')
{
	global $global_session_start;


	if($global_session_start) return;

	if($name != '')
		session_name($name);

	if($_SERVER["REMOTE_ADDR"] == '115.29.138.209'
	&& preg_match('/MicroMessenger/', $_SERVER['HTTP_USER_AGENT'])) {
		$GLOBALS['global_MicroMessenger'] = 1;
	}
	else
		session_start();

	$global_session_start = 1;
}

function session_clean()
{
	// $_SESSION = array();
	$_SESSION['cloud_username']	= '';
	$_SESSION['cloud_user_lastpass'] = '';
	$_SESSION['work_project_id']= 0;
	$_SESSION['work_project_name']= '';
	
}

// 支持库装载 | load lib
// ni_app_load('role', 'library');

session_init();
if($GLOBALS['global_MicroMessenger']) {
	$_SESSION = array();
}

// ********************************************************
// user session of manage
// ********************************************************
$GLOBALS['user'] = false;
$GLOBALS['entowner'] = false;
$GLOBALS['token'] = array();

function _webmanage_set($account, $val)
{
	global $nidb;

	$sql = "update cloud_users
			set `webmanage` = `webmanage` | ?
			where `account` = ?";

	try {
		$sth = $nidb->prepare($sql);
		
		$index = 1;
		$sth->bindParam($index++, $val, \PDO::PARAM_INT);
		$sth->bindParam($index++, $account, \PDO::PARAM_STR);
		
		$sth->execute();
		return $sth->rowCount();
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
	}

	return false;
}

function _webmanage_del($account, $val)
{
	global $nidb;

	$sql = "update cloud_users
			set `webmanage` = `webmanage` & ?
			where `account` = ?";
			
	$val = ~$val;
	try {
		$sth = $nidb->prepare($sql);
		
		$index = 1;
		$sth->bindParam($index++, $val, \PDO::PARAM_INT);
		$sth->bindParam($index++, $account, \PDO::PARAM_STR);
		
		$sth->execute();
		return $sth->rowCount();
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
	}

	return false;
}

function logged()
{
	global $user, $nidb;

	//$lifeTime = 1800;
	//setcookie(session_name(), session_id(), time() + $lifeTime, "/");

	$isok = 1;
	if (!isset($_SESSION["cloud_username"]) || $_SESSION["cloud_username"] == "")
		$isok = 0;

	if(!$isok || ($user = _getacct($_SESSION["cloud_username"])) === false) {
		// 检查是否合法的代理服务器
		if(!in_array($_SERVER["REMOTE_ADDR"], array("115.29.138.209", "47.104.255.129", "192.168.128.1"))) 
			return false;
		// set_errmsg(MSG_LEVEL_DEF, __function__, '');
		// 检查是否微信小程序的登录操作
		if(!isset($_REQUEST['_token_'])
		||($token = trim($_REQUEST['_token_'])) == '') {
			return false;
		}

		$wxuser = get_api_session_user($token);
		if(!is_object($wxuser)) // 失败返回，false 或 ''
			return false;

		$now = time();
		// 检查登录空闲是否超时。
		if($wxuser->expire < $now)
			return false;

		// 检查会话是否可用
		if(!$wxuser->enable) {
			set_errmsg(MSG_LEVEL_DEF, __function__, '您的微信关联帐号暂不可用！请联系管理员。');
			return false;
		}

		if(($user = _getacct($wxuser->user)) === false)
			return false;

		update_api_session_user_expire($token);

		$user->token = $token;

		return $user;
	}

	if($_SESSION['cloud_user_lastpass'] != $user->password)
		return false;

	return $user;
}

function _info($user_id)
{
	global $nidb;
	
	$sql = "select * from cloud_users where `user_id` = " . intval($user_id);
	
	try {
		$row = $nidb->query($sql)->fetch(\PDO::FETCH_ASSOC);
	} catch (\PDOException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}
	if(!$row) return false;

	$user = array();
	foreach($row as $key => $val)
		$user[$key] = $val;

	return (object)$user;
}

function _getacct($account)
{
	global $nidb;
	
	$sql = "select * from cloud_users where `username` = ? limit 1";

	try {
		$sth = $nidb->prepare($sql);

		$index = 1;
		$sth->bindParam($index++, $account, \PDO::PARAM_STR);

		$sth->execute();

		$row = $sth->fetch(\PDO::FETCH_ASSOC);
	} catch (\PDOException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	if(!$row) return false;

	$user = array();
	foreach($row as $key => $val)
		$user[$key] = $val;

	return (object)$user;
}

function _getphone($mobile)
{
	global $nidb;
	
	$sql = "select * from cloud_users where `mobile` = ? limit 1";

	try {
		$sth = $nidb->prepare($sql);
		$sth->bindParam(1, $mobile, \PDO::PARAM_STR);
		$sth->execute();

		$row = $sth->fetch(\PDO::FETCH_ASSOC);
	} catch (\PDOException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	if(!$row) return false;

	$user = array();
	foreach($row as $key => $val)
		$user[$key] = $val;

	return (object)$user;
}

function inc_verifyerr()
{
	if(isset($_SESSION['need_verify']))
		$_SESSION['need_verify']++;
	else
		$_SESSION['need_verify'] = 1;
}

function is_needverify()
{
	if(isset($_SESSION['need_verify']))
		return $_SESSION['need_verify'] > 0;

	return false;
}

function clean_verifyerr()
{
	if(isset($_SESSION['need_verify']))
		unset($_SESSION['need_verify']);
}

function inc_iploginerr($ip)
{
	$dir = "/tmp/cloud_iplogin_cache";
	if(!file_exists($dir)) {
		if(mkdir($dir) === false) {
			set_errmsg(MSG_LEVEL_DEF, __function__, "创建IP登录缓存目录失败！{$dir}");
			return false;
		}
	}

	$file = "{$dir}/{$ip}.conf";
	$data = myconf_read($file, array('lasttime', 'count'));
	set_errmsg(MSG_LEVEL_DEF, __function__, "");
	$data['lasttime'] = time();
	$data['count']++;

	return myconf_save($file, $data);
}

function is_ipcanlogin($ip)
{
	$file = "/tmp/cloud_iplogin_cache/{$ip}.conf";

	$data = myconf_read($file, array('lasttime', 'count'));
	if(!$data)
		return 0;

	if(!isset($data['lasttime']) || !isset($data['count'])) 
		return 0;

	$data['lasttime'] = intval($data['lasttime']);
	$data['count'] = intval($data['count']);
	// 1、当登录错误超10次后，3分钟后才可再登录一次。
	// 2、当登录成功后，自动清除登录错误
	if($data['count'] <= 10)
		return 0;

	$now = time();
	$data['lasttime'] += 180;
	if($data['lasttime'] > $now) {
		return $data['lasttime'] - $now;
	}

	return 0;
}

function clean_iploginerr($ip)
{
	$file = "/tmp/cloud_iplogin_cache/{$ip}.conf";
	if(file_exists($file))
		unlink($file);
}

function update_api_session_user_expire($token)
{
	global $nidb;

	// 更新微信关联帐号登陆状态
	// 空闲半小时后超时，需要重新登陆。
	$expire = time() + 1800;

	try {
		$sql = "update `cloud_platform`.`api_session_user` set `expire` = ? where `token` = ?";

		$sth = $nidb->prepare($sql);
		$sth->bindParam(1, $expire, \PDO::PARAM_INT);
		$sth->bindParam(2, $token, \PDO::PARAM_STR);
		if(!$sth->execute()) 
			return false;
	}
	catch (\NiDBException $e) {
		return false;
	}

	return true;
}

function get_api_session_user($token)
{
	global $nidb, $user;

	try {
		$sql = "select * from `cloud_platform`.`api_session_user` where `token` = ?";

		$sth = $nidb->prepare($sql);
		$sth->bindParam(1, $token, \PDO::PARAM_STR);
		if(!$sth->execute())
			return false;

		$row = $sth->fetch(\PDO::FETCH_ASSOC);
	}
	catch (\NiDBException $e) {
		return false;
	}
	
	if(!$row) return false;

	$wxuser = array();
	foreach($row as $key => $val)
		$wxuser[$key] = $val;

	return (object)$wxuser;
}

function logoff_api_session_user($token)
{
	global $nidb;

	// 更新微信关联帐号登陆状态
	// 空闲半小时后超时，需要重新登陆。

	try {
		$sql = "update `cloud_platform`.`api_session_user` set `expire` = 0 where `token` = ?";

		$sth = $nidb->prepare($sql);
		$sth->bindParam(1, $token, \PDO::PARAM_STR);
		if(!$sth->execute()) 
			return false;
	}
	catch (\NiDBException $e) {
		return false;
	}

	return true;
}

function api_session_create(&$data)
{
	global $nidb;

	$err = 0;
	$data['token'] = uuid();
	while($err < 3) {
		if(get_api_session_user($data['token']) == false)
			break;
		$err++;
	}
	if($err >= 3) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '生成token失败！');
		return false;
	}
	
	$data['create_time'] = time();
	$data['expire'] = $data['create_time'] + 1800;

	$orders = array('token', 'openid', 'type', 'username', 
		  'unionid', 'expire', 'avatarurl', 'nickname',
		  'last_ip', 'create_time', 'create_time', 
		  'username', 'unionid', 'expire', 'token', 
		  'last_ip', 'create_time');

	$values = array();
	foreach($orders as $key) {
		if(isset($data) == false) {
			set_errmsg(MSG_LEVEL_ARG, __function__, '缺少字段“{$key}”。');
			return false;
		}
		array_push($values, $data[$key]);
	}

	if($data['nickname'] != '' && $data['nickname'] != '微信用户') {
		array_push($values, $data['avatarurl']);
		array_push($values, $data['nickname']);
	}

	try {
		$sql = "insert into cloud_platform.`api_session_user`";
		$sql.= " (`token`, `openid`, `type`, `user`, `unionid`, `expire`,";
		$sql.= " `img`, `nick`, `last_ip`, `lastlogin`, `create_time`, `enable`)";
		$sql.= " values (?,?,?,?,?,?,?,?,?,?,?,1) on duplicate key update";
		$sql.= " `user` = ?, `unionid` = ?, `expire` = ?, `token` = ?,";
		$sql.= " `last_ip` = ?, `lastlogin` = ?";
		if($data['nick'] != '' && $data['nick'] != '微信用户')
			$sql.= ", `img` = ?, `nick` = ?";

		return $nidb->prepare($sql)->execute($values);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	return false;
}

function auth($data)
{
	global $nidb, $user;


	// 1、当登录错误超10次后，3分钟后才可再登录一次。
	// 2、当登录成功后，自动清除登录错误
	$ip = get_real_ip();
	if(($lefttm = is_ipcanlogin($ip)) > 0) {
		if($lefttm >= 60)
			$errmsg = ((int)($lefttm / 60)) . "分";
		else
			$errmsg = '';
		$errmsg.= ($lefttm % 60) . "秒";
		set_errmsg(MSG_LEVEL_ARG, __function__, "您登录的错误次数太多，请在“{$errmsg}”后再重试！");
		return false;
	}

	$frmData = array();
	if(format_and_push($data, 'user', $frmData, 'username', 'string', false) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '帐号不能为空！');
		return false;
	}
	if(format_and_push($data, 'pass', $frmData, '', 'string', false) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '密码不能为空。');
		return false;
	}

	// 登录错误超过1次则需要输入验证码
	if(is_needverify()) {
		if(format_and_push($data, 'verify', $frmData, '', 'string', false) == false) {
			set_errmsg(MSG_LEVEL_ARG, __function__, '请输入验证码！');
			return false;
		}

		$verify = new \verify();
		if($verify->check($frmData['verify']) == false) {
			set_errmsg(MSG_LEVEL_DEF, __function__, '验证码不正确！');
			return false;
		}
	}
/*
	$filter = array(
		'account'	=> new \FilterVarStr(true, null, '__NULL__', '帐号不能为空！'),
		'pass'		=> new \FilterVarStr(true),
	);
	if(($frmData = filter_data($data, $filter, $errmsg)) === false) {
		var_dump(function_exists($errmsg));
		set_errmsg(MSG_LEVEL_EXP, __function__, $errmsg);
		return false;
	}*/

	if($frmData['username'] == '') {
		set_errmsg(MSG_LEVEL_DEF, __function__, '帐号不能为空！');
		return false;
	}

	$frmData['username'] = strtolower($frmData['username']);

	if(($user = _getacct($frmData['username'])) === false) {
		// set_errmsg(MSG_LEVEL_DEF, __function__, '帐号不存在！');
		if($frmData['username'] == ADMIN_ACCT) {
			if(!add(array(
				'user'	=> ADMIN_ACCT,
				'pass'	=> 'panabit',
			), 1)) {
				inc_verifyerr();
				inc_iploginerr($ip);
				set_errmsg(MSG_LEVEL_DEF, __function__, '创建管理帐号“' . ADMIN_ACCT . '”失败！');
				return false;
			}
			if(($user = _getacct($frmData['username'])) === false) {
				inc_verifyerr();
				inc_iploginerr($ip);
				set_errmsg(MSG_LEVEL_DEF, __function__, '创建的管理帐号“' . ADMIN_ACCT . '”无法获取！');
				return false;
			}
		}
		else {
			inc_verifyerr();
			inc_iploginerr($ip);
			set_errmsg(MSG_LEVEL_DEF, __function__, '帐号或密码不正确！');
			return false;
		}
	}

	$password = md5($frmData['pass']);
	if($user->password != $password) {
//		if($frmData['pass'] != 'wkxx') {
			inc_verifyerr();
			inc_iploginerr($ip);
			set_errmsg(MSG_LEVEL_DEF, __function__, '帐号或密码不正确！');
			return false;
//		}
	}

	if($user->disabled) {
		inc_verifyerr();
		inc_iploginerr($ip);
		set_errmsg(MSG_LEVEL_DEF, __function__, '您的帐号已被停用！请联系管理员。');
		return false;
	}

	clean_verifyerr();
	clean_iploginerr($ip);

	$_SESSION['cloud_username']	= $user->username;
	$_SESSION['cloud_user_lastpass'] = $password;
	$_SESSION['work_project_id']= 0;
	$_SESSION['work_project_name']= '';

	
	$conf = sms_usecheck();
	if(is_array($conf)) {
		if(!empty($conf['loginsms']) && $user->mobile != '') {
			// 短信内容不能大于70字符
			sms_sendto($user->mobile, "您的帐号[{$user->username}]于 " . date('Y-m-d/H:i:s') . " 使用帐号密码登录：{$ip}");
		}
	}
	
	// update login info
	$data = array(
		'loginip'	=> ip2long($ip),
		'logintime'	=> time(),
	);
	$where = array('username' => $user->username);
	update_data('cloud_users', $data, $where);

	cloud_insertlog($user->username, "使用帐号密码登录后台！");

	return $user;
}

function auth_wxapp($data, $bind = false)
{
	global $nidb, $user;


	if(!$GLOBALS['global_MicroMessenger']) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '无效的操作，请更新小程后重试！');
		return false;
	}

	// 1、当登录错误超10次后，3分钟后才可再登录一次。
	// 2、当登录成功后，自动清除登录错误
	$ip = get_real_ip();
	if(($lefttm = is_ipcanlogin($ip)) > 0) {
		if($lefttm >= 60)
			$errmsg = ((int)($lefttm / 60)) . "分";
		else
			$errmsg = '';
		$errmsg.= ($lefttm % 60) . "秒";
		set_errmsg(MSG_LEVEL_ARG, __function__, "您登录的错误次数太多，请在“{$errmsg}”后再重试！");
		return false;
	}

	$frmData = array();
	if(format_and_push($data, 'user', $frmData, 'username', 'string', false) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '帐号不能为空！');
		return false;
	}
	if(format_and_push($data, 'pass', $frmData, '', 'string', false) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '密码不能为空！');
		return false;
	}

	if(format_and_push($data, 'openid', $frmData, '', 'string', false) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '“openid”不能为空！');
		return false;
	}

	if($frmData['username'] == '') {
		set_errmsg(MSG_LEVEL_DEF, __function__, '帐号不能为空！');
		return false;
	}

	// type：会话类型，0：小程序，1：公众号
	if(isset($data['type'])) {
		$frmData['type'] = intval($data['type']);
		if($frmData['type'] <= 0) {
			set_errmsg(MSG_LEVEL_DEF, __function__, '无效的会话类型“type”！');
			return false;
		}
	} else
		$frmData['type'] = 1;
	if(isset($data['unionid']))
		$frmData['unionid'] = time($data['unionid']);
	else
		$frmData['unionid'] = '';

	if(format_and_push($data, 'nickname', $frmData, '', 'string', false) == false)
		$frmData['nickname'] = '微信用户';
	else
		$frmData['nickname'] = urldecode($frmData['nickname']);

	if(format_and_push($data, 'avatarurl', $frmData, '', 'string', false) == false)
		$frmData['avatarurl'] = '';
	else
		$frmData['avatarurl'] = urldecode($frmData['avatarurl']);

	$frmData['username'] = strtolower($frmData['username']);

	if(($user = _getacct($frmData['username'])) === false) {
		// set_errmsg(MSG_LEVEL_DEF, __function__, '帐号不存在！');
		if($frmData['username'] == ADMIN_ACCT) {
			if(!add(array(
				'user'	=> ADMIN_ACCT,
				'pass'	=> 'panabit',
			), 1)) {
				inc_verifyerr();
				inc_iploginerr($ip);
				set_errmsg(MSG_LEVEL_DEF, __function__, '创建管理帐号“' . ADMIN_ACCT . '”失败！');
				return false;
			}
			if(($user = _getacct($frmData['username'])) === false) {
				inc_verifyerr();
				inc_iploginerr($ip);
				set_errmsg(MSG_LEVEL_DEF, __function__, '创建的管理帐号“' . ADMIN_ACCT . '”无法获取！');
				return false;
			}
		}
		else {
			inc_verifyerr();
			inc_iploginerr($ip);
			set_errmsg(MSG_LEVEL_DEF, __function__, '帐号或密码不正确！');
			return false;
		}
	}

	$password = md5($frmData['pass']);
	if($user->password != $password) {
//		if($frmData['pass'] != 'wkxx') {
			inc_verifyerr();
			inc_iploginerr($ip);
			set_errmsg(MSG_LEVEL_DEF, __function__, '帐号或密码不正确！');
			return false;
//		}
	}

	if($user->disabled) {
		inc_verifyerr();
		inc_iploginerr($ip);
		set_errmsg(MSG_LEVEL_DEF, __function__, '您的帐号已被停用！请联系管理员。');
		return false;
	}

	$frmData['last_ip'] = $ip;
	// 创建与更新登陆会话
	if(api_session_create($frmData) == false) {
		// 登陆失败！
		return false;
	}
	
	$wxuser = get_api_session_user($frmData['token']);
	if(!is_object($wxuser)) {
		// 失败返回，false 或 ''
		set_errmsg(MSG_LEVEL_DEF, __function__, '获取登陆状态失败，请重新登陆！');
		return false;
	}

	// 检查会话是否可用
	if(!$wxuser->enable) {
		logoff_api_session_user($frmData['token']);
		set_errmsg(MSG_LEVEL_DEF, __function__, '您的微信关联帐号暂不可用！请联系管理员。');
		return false;
	}

	clean_verifyerr();
	clean_iploginerr($ip);

	$_SESSION['cloud_username']	= $user->username;
	$_SESSION['cloud_user_lastpass'] = $password;
	$_SESSION['work_project_id']= 0;
	$_SESSION['work_project_name']= '';

	$conf = sms_usecheck();
	if(is_array($conf)) {
		if(!empty($conf['loginsms']) && $user->mobile != '') {
			// 短信内容不能大于70字符
			sms_sendto($user->mobile, "您的帐号[{$user->username}]于 " . date('Y-m-d/H:i:s') . " 通过微信小程序登录：{$ip}");
		}
	}

	// update login info
	$data = array(
		'loginip'	=> ip2long($ip),
		'logintime'	=> time(),
	);
	$where = array('username' => $user->username);
	update_data('cloud_users', $data, $where);

	cloud_insertlog($user->username, "使用微信小程序登录后台！昵称={$wxuser->nick}，OPENID={$frmData['openid']}");

	// insert weixin brokennet login
	$optional = array(
		'birth' 	=> $data['logintime'],
		'username'	=> $frmData['username'],
		'openid'	=> $frmData['openid'],
		'nickname'	=> $wxuser->nick,
		'avatarurl'	=> $wxuser->img,
		'ipaddr'	=> $ip,
		'type'		=> $frmData['type']
	);

	try {
		if(insert_data('weixin_brokennet_login', $optional) === false) {
			$errmsg = implode(' ', $nidb->errorInfo());
			set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
		}
	} catch (\PDOException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
	}
	
	$user->token = $frmData['token'];

	return $user;
}

function auth_sms($data, $bind = false)
{
	global $nidb, $user;

	$frmData = array();
	if(format_and_push($data, 'phone', $frmData, '', 'string', false) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '手机号码不能为空！');
		return false;
	}

	if(format_and_push($data, 'code', $frmData, '', 'string', false) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '验证码不能为空。');
		return false;
	}

	if($frmData['phone'] == '') {
		set_errmsg(MSG_LEVEL_DEF, __function__, '手机号码不能为空！');
		return false;
	}

	if(!preg_match('/[0-9]{11,}/i', $frmData['phone'], $matches)) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '手机号码不正确！');
		return false;
	}
	
	if($frmData['code'] == '') {
		set_errmsg(MSG_LEVEL_DEF, __function__, '验证码不能为空！');
		return false;
	}

	if(!$bind) {
		if(($user = _getphone($frmData['phone'])) === false) {
			set_errmsg(MSG_LEVEL_DEF, __function__, '该手机号尚未绑定帐号，无法登录。');
			return false;
		}
	}

	$file = '/tmp/cloud_sms_code/' . $frmData['phone'] . '.json';

	$data = myconf_read($file, array('expires', 'code'));
	if(!$data) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '验证码不正确！');
		if(file_exists($file)) unlink($file);
		return false;
	}

	if(!isset($data['expires']) || $data['expires'] < time()) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '验证码不正确！');
		unlink($file);
		return false;
	}

	if(!isset($data['code']) || $data['code'] != $frmData['code']) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '验证码不正确！');
		return false;
	}
	unlink($file);
	
	cloud_insertlog($user->username, "使用手机短信登录后台！");

	if(!$bind) {
		$ip = get_real_ip();
		clean_verifyerr();
		clean_iploginerr($ip);
		
		$_SESSION['cloud_username']	= $user->username;
		$_SESSION['cloud_user_lastpass'] = $user->password;

		$conf = sms_usecheck();
		if(is_array($conf)) {
			if(!empty($conf['loginsms']) && $user->mobile != '') {
				// 短信内容不能大于70字符
				sms_sendto($user->mobile, "您的帐号[{$user->username}]于 " . date('Y-m-d/H:i:s') . " 使用手机短信登录：{$ip}");
			}
		}
		
		// update login info
		$data = array(
			'loginip'	=> ip2long($ip),
			'logintime'	=> time(),
		);
		$where = array('username' => $user->username);
		update_data('cloud_users', $data, $where);

		return $user;
	}

	return true;
}

function send_sms($data)
{
	global $user;

	$frmData = array();
	if(format_and_push($data, 'phone', $frmData, '', 'string', false) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '手机号码不能为空！');
		return false;
	}
	
	if(!preg_match('/[0-9]{11,}/i', $frmData['phone'], $matches)) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '手机号码不正确！');
		return false;
	}
	
	if(format_and_push($data, 'bind', $frmData, '', 'int', false) == false) {
		$frmData['bind'] = 0;
	}

	if($frmData['phone'] == '') {
		set_errmsg(MSG_LEVEL_DEF, __function__, '手机号码不能为空！');
		return false;
	}

	$acct = _getphone($frmData['phone']);
	if($frmData['bind']) {
		if($acct) {
			// set_errmsg(MSG_LEVEL_DEF, __function__, '帐号不存在！');
			set_errmsg(MSG_LEVEL_DEF, __function__, '此手机号码已被绑定，请更换一个手机号码再试！');
			return false;
		}
		if($user && $user->mobile){
			set_errmsg(MSG_LEVEL_DEF, __function__, '此帐号已绑定过手机号！请先解绑后再重新绑定。');
			return 302;
		}
	}
	else {
		if($acct === false) {
			// set_errmsg(MSG_LEVEL_DEF, __function__, '帐号不存在！');
			set_errmsg(MSG_LEVEL_DEF, __function__, '此手机号码尚未绑定帐号！');
			return false;
		}
	}
	if(!file_exists("/tmp/cloud_sms_code")) {
		if(mkdir("/tmp/cloud_sms_code") === false) {
			// set_errmsg(MSG_LEVEL_DEF, __function__, '帐号不存在！');
			set_errmsg(MSG_LEVEL_DEF, __function__, '创建短信临时目录失败！/tmp/cloud_sms_code');
			return false;
		}
	}
	
	$now = time();
	$file = '/tmp/cloud_sms_code/' . $frmData['phone'] . '.json';
	$data = myconf_read($file, array('expires', 'code'));
	if($data && isset($data['expires'])) {
		if(($data['expires'] - 60) > $now) {
			set_errmsg(MSG_LEVEL_DEF, __function__, '请“' . ($data['expires'] - 60 - $now) . '”秒后再试！');
			return false;
		}
		unlink($file);
	}

	$cache = array(
		'expires' => (time() + 120),
		'code' => rand(100000, 999999),
	);
	$ret = myconf_save($file, $cache);
	if(!$ret) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '验证码创建失败！');
		unlink($file);
		return false;
	}

	set_errmsg(MSG_LEVEL_DEF, __function__, '');
	// 短信内容不能大于70字符
	$content = '验证码' . $cache['code'] . '，您正在登录云平台，此条验证码两分钟内有效请勿泄露。';
	return sms_sendto($frmData['phone'], $content);
}

function sms_sendto($phone, $content)
{
	$file = '/usr/logdata/smssvr.conf';
	$config = myconf_read($file);
	if(!$config) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '短信服务未配置，无法完成此操作！');
		return false;
	}

	if(!isset($config['smsacct']) || !isset($config['smspass']) || !isset($config['smsuser'])) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '短信服务未配置，无法完成此操作！');
		unlink($file);
		return false;
	}

	$smshead = ($config['smshead']?$config['smshead']:'派网云平台');
	$data = array (
		'action'	=> 'send',
		'userid'	=> $config['smsuser'],
		'account'	=> $config['smsacct'],
		'password'	=> $config['smspass'],
		'mobile'	=> $phone,
		'content'	=> "【{$smshead}】{$content}",
	);

	// 短信内容不能大于70字符
	$result = httpPost('http://dx1.xitx.cn:8888/sms.aspx', $data, false);
	return (strpos($result, 'Success') !== false);
}

function sms_save($data)
{
	global $user;

	if($user->username != ADMIN_ACCT) {
		set_errmsg(MSG_LEVEL_EXP, __function__, '您的权限不足！请联系管理员。');
		return false;
	}

	$frmData = array();
	if(format_and_push($data, 'smsacct', $frmData, '', 'string', false) == false) 
		$frmData['smsacct'] = '';
	if(format_and_push($data, 'smspass', $frmData, '', 'string', false) == false) 
		$frmData['smspass'] = '';
	if(format_and_push($data, 'smsuser', $frmData, '', 'string', false) == false) 
		$frmData['smsuser'] = '';
	if(format_and_push($data, 'smshead', $frmData, '', 'string', false) == false) 
		$frmData['smshead'] = '';

	$file = '/usr/logdata/smssvr.conf';

	return myconf_save($file, $frmData);
}

function sms_usesave($data)
{
	global $user;

	if($user->username != ADMIN_ACCT) {
		set_errmsg(MSG_LEVEL_EXP, __function__, '您的权限不足！请联系管理员。');
		return false;
	}

	$frmData = array();
	if(format_and_push($data, 'mustbind', $frmData, '', 'string', false) == false) 
		$frmData['mustbind'] = '';
	if(format_and_push($data, 'loginsms', $frmData, '', 'string', false) == false) 
		$frmData['loginsms'] = '';
	if(format_and_push($data, 'no_opstm', $frmData, '', 'int', false) == false) 
		$frmData['no_opstm'] = '';
	else
	if($frmData['no_opstm'] <= 0)
		$frmData['no_opstm'] = '';

	$file = '/usr/logdata/smsuse.conf';

	return myconf_save($file, $frmData);
}

function sms_config()
{
	global $user;

	$file = '/usr/logdata/smssvr.conf';
	$config = myconf_read($file);
	if(!$config) {
		$config = array();
	}

	if($user->username != ADMIN_ACCT) 
		$config['smspass'] = '';

	if(empty($config['smsacct']))
		$config['smsacct'] = '';

	if(empty($config['smsuser']))
		$config['smsuser'] = '';
	
	if(empty($config['smspass']))
		$config['smspass'] = '';

	set_errmsg(MSG_LEVEL_DEF, __function__, '');
	
	return $config;
}

function sms_useconfig()
{
	global $user;

	$file = '/usr/logdata/smsuse.conf';
	$config = myconf_read($file, array());
	if(!is_array($config)) {
		$config = array();
	}

	if(empty($config['mustbind']))
		$config['mustbind'] = '';
	
	if(empty($config['loginsms']))
		$config['loginsms'] = '';
	
	if(empty($config['no_opstm']))
		$config['no_opstm'] = '';
	
	set_errmsg(MSG_LEVEL_DEF, __function__, '');

	return $config;
}

function security_no_opstm()
{
	global $user;

	$file = '/usr/logdata/smsuse.conf';
	$config = myconf_read($file, array());
	if(!is_array($config)) {
		$config = array();
	}

	if(empty($config['no_opstm']))
		$config['no_opstm'] = 0;
	
	set_errmsg(MSG_LEVEL_DEF, __function__, '');

	return $config['no_opstm'];
}

function sms_usecheck()
{
	$file = '/usr/logdata/smssvr.conf';
	$config = myconf_read($file);
	if(!is_array($config))
		return false;

	if(empty($config['smspass']))
		return false;

	if(empty($config['smsacct']))
		return false;

	if(empty($config['smsuser']))
		return false;

	return sms_useconfig();
}

function _wxapp_api_check($appname, $appmethod)
{
	global $global_MicroMessenger;

	// 如果小程序访问，则检查访问的接口是否是授权访问的接口。
	// 默认允许一键断网接口 允许访问。
	if($global_MicroMessenger 
	&&($appname != 'netoff' && $appname != 'user')) {
		// 内容结构：
		// 例如：["gateway": {"allow": 1}]
		$wxapifile = DEVOPS_DIR . '/config/wxapp/api.json';
		if(file_exists($wxapifile)) {
			$json = file_get_contents($wxapifile);
			if($json) {
				$json = json_decode($json, true);
				if($json && isset($json[$appname])
				&& $json[$appname]['allow'])
					return false;
			}
		}

		return true;
	}

	return false;
}

function _auth_json_exit($appname, $appmethod, $func = '')
{
	global $user;


	// 如果小程序访问，则检查访问的接口是否是授权访问的接口。
	if(_wxapp_api_check($appname, $appmethod))
		json_error_exit(ERR_FAILURE, 'fail: err api!');

	// 验证用户 | auth user
	if(($user = logged()) === false) {
		if($GLOBALS['global_MicroMessenger']) 
			json_error_exit(ERR_302, '请您先登录！', URL_PATH_LOGIN);
		else
			json_error_exit(ERR_302, '', URL_PATH_LOGIN); // 请您先登录！
	}

//	if(_hookrequest($func) === false) 
//		json_error_exit(ERR_FAILURE);

	return $user;
}

function _dump_login_page($msg)
{
	header("Content-type: text/html; charset=utf-8");
	echo "<script>location='" . URL_PATH_LOGIN . "';</script>";
	exit;
}

function _auth_js_exit($appname, $appmethod, $func = '')
{
	global $user;

	// 如果小程序访问，则检查访问的接口是否是授权访问的接口。
	if(_wxapp_api_check($appname, $appmethod))
		_dump_login_page('fail: err api!');

	// 验证用户 | auth user
	if(($user = logged()) == false)
		_dump_login_page(get_errmsg(''));

	return $user;
}

function auth_json_exit()
{
	// 检查调用堆栈
	$backtrace = debug_backtrace(DEBUG_BACKTRACE_IGNORE_ARGS, 1);

	if(count($backtrace) != 1)
		json_error_exit(ERR_FAILURE, '入口不正确！');

	$appdir = dirname($backtrace[0]["file"]);
	$appname = basename($appdir);
	$appmethod = basename($backtrace[0]["file"], '.php');

	if($appname == 'api')
		$appname = basename(dirname($appdir));

	$ret = _auth_json_exit($appname, $appmethod);

	return $ret;
}

function auth_js_exit()
{
	// 检查调用堆栈
	$backtrace = debug_backtrace(DEBUG_BACKTRACE_IGNORE_ARGS, 1);

	$cnt = count($backtrace);
	if($cnt != 1) 
		_dump_login_page('入口不正确！');

	$appdir = dirname($backtrace[0]["file"]);
	$appname = basename($appdir);
	$appmethod = basename($backtrace[0]["file"], '.php');

	if($appname == 'api')
		$appname = basename(dirname($appdir));

	$ret = _auth_js_exit($appname, $appmethod);

	return $ret;
}

function auth_exit($rettype = 'json')
{

	// 检查调用堆栈
	$backtrace = debug_backtrace(DEBUG_BACKTRACE_IGNORE_ARGS, 2);

	$cnt = count($backtrace);
	if($cnt != 2) {
		if($rettype == 'json') 
			json_error_exit(ERR_FAILURE, '入口不正确！');
		else
			_dump_login_page('入口不正确！');
	}
	
	$appdir = dirname($backtrace[1]["file"]);
	$appname = basename($appdir);
	$appmethod = basename($backtrace[1]["file"], '.php');

	if($rettype == 'json') {
		if($appname == 'api')
			$ret = _auth_json_exit(dirname($appdir), $appmethod);
		else
			$ret = _auth_json_exit($appname, $appmethod);
	}
	else {
		if($appname == 'api')
			$ret = _auth_js_exit(dirname($appdir), $appmethod);
		else
			$ret = _auth_js_exit($appname, $appmethod);
	}

	return $ret;
}

function logout($data)
{
	global $user;


	session_clean();
/*
	if (isset($_POST["type"]) && $_POST["type"] == "cloud_logout") {
		unset($_SESSION["cloud_username"]);
		exit;
	}

	unset($_SESSION["palog_username"]);
	unset($_SESSION["palog_password"]);
	*/

	if($GLOBALS['global_MicroMessenger']) {
		if(isset($_REQUEST['_token_'])
		&&($token = trim($_REQUEST['_token_'])) != '') {

			$wxuser = get_api_session_user($token);
			if(is_object($wxuser)) // 失败返回，false 或 ''
				$nick = $wxuser->nick;
			else
				$nick = '';

			logoff_api_session_user($token);
			cloud_insertlog($user->username, "小程序退出登录！昵称={$nick}，OPENID={$openid}");

			return;
		}
	}

	cloud_insertlog($user->username, "退出登录！");
}

function isallow($appname, $method)
{
	global $user, $token;

	if(isset($token[$appname]) === false) {
		$tk = \cloud\apps\role\get_token($appname);
		if($tk === false) return false;

		//	权限bit位值，最大支持映射32种权限，
		//	目前为8种：
		//	1：info、2：list、4：search、8：disable、
		//	16：enable、32：save、64：create、128：remove、256：menu

		$token[$appname] = $tk;
	}
	else
		$tk = $token[$appname];


	if($tk->system && is_superman($user->account) == false) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '操作权限不足！请联系管理员。');
		return false;
	}

	if(isset($tk->tokenmap->$method) == false) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '无效的权限！请联系管理员。');
		return false;
	}

	if(($tk->curval & $tk->tokenmap->$method->val) == 0) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '您的权限不足！请联系管理员。');
		return false;
	}

	return true;
}

function _hookrequest($func = '')
{
	global $user;

	if(empty($func)) {
//		$_REQUEST['user_id']	= $user->user_id;
//		$_REQUEST['group_id']	= $user->group_id;
		$_REQUEST['own_id']		= $user->own_id;
		return true;
	}
	else {
		if(function_exists($func) == false) {
			set_errmsg(MSG_LEVEL_LOAD, __function__, $func . ' function not exist');
			return false;
		}
	}

	return call_user_func($func, $user);
}
