<?php

function get_query_page($data)
{
	$optional = array();

	if(format_and_push($data, 'sort', $optional, '', 'string', false) == false)
		$optional['sort'] = '';
	
	if(format_and_push($data, 'page', $optional, '', 'int', false) == false)
		$optional['page'] = 1;
	
	if(format_and_push($data, 'limit', $optional, '', 'int', false) == false)
		$optional['limit'] = 20;
	else
		if($optional['limit'] <= 0) $optional['limit'] = 20;

	$optional['sortdesc'] = 0;
	if(format_and_push($data, 'g_ascdesc', $optional, 'ascdesc', 'string', false)) {
		if ($optional['sortdesc'] == 'desc')
			$optional['sortdesc'] = 2;
		else
		if ($optional['sortdesc'] == 'asc')
			$optional['sortdesc'] = 1;
		else
			$optional['sortdesc'] = intval($optional['sortdesc']);
	}

	return $optional;
}

function cloud_insertlog($user, $cont)
{
	global $nidb;
	
	$frmData = array(
		'user' => $user,
		'time' => time(),
		'cont' => $cont,
		'ipaddr' => $_SERVER["REMOTE_ADDR"],
	);
	try {
		if(insert_data('cloud_log', $frmData) === false) {
			$errmsg = implode(' ', $nidb->errorInfo());
			set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
			return false;
		}
		$id = $nidb->lastInsertId();
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	return $id;
}

function operation_logger($obj, $str)
{
	global $nidb, $user;
	
	$frmData = array(
		'user'		=> $user->username,
		'ope_time'	=> time(),
		'obj'		=> $obj,
		'cont'		=> $str,
	);
	try {
		if(insert_data('operation_log', $frmData) === false) {
			$errmsg = implode(' ', $nidb->errorInfo());
			set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
			return false;
		}
		$id = $nidb->lastInsertId();
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	return $id;
}

function to_utf8($word)
{
	if (json_encode($word) == false
		// is utf8 ?
	|| !preg_match("/^([".chr(228)."-".chr(233)."]{1}[".chr(128)."-".chr(191)."]{1}[".chr(128)."-".chr(191)."]{1}){1}/",$word) == true || preg_match("/([".chr(228)."-".chr(233)."]{1}[".chr(128)."-".chr(191)."]{1}[".chr(128)."-".chr(191)."]{1}){1}$/",$word) == true || preg_match("/([".chr(228)."-".chr(233)."]{1}[".chr(128)."-".chr(191)."]{1}[".chr(128)."-".chr(191)."]{1}){2,}/",$word)) {
		$word = iconv("gbk", "utf-8//translit", $word);
		if($word === false)
			$word = '';
	}

	return $word;
}

function hav_logoff() {
	if(file_exists('/root/panalog.cloud')) return 0;
	$conf = myconf_read('/usr/logd/bin/log.conf', array('log_off'));
	return !(isset($conf['log_off']) && intval($conf['log_off']));
}

/*
 * 多国语言转换函数
 * 
 */
/*
function language_jslib_print($dir)
{
	if(isset($_SESSION['lang']))
		$lang = $_SESSION['lang'];
	else
		$lang = 'zh';

	$file = "{$dir}/{$lang}.json";
	if(file_exists($file))
		$contents = file_get_contents($file);
	else
		$contents = '{}';
	return '<!-- language library, now lang="' . $lang . '" -->
		<script type="text/javascript">
			_paga_language_ = ' . $contents . ';
			function _lang(id, default_text)
			{
				if(arguments.length <= 0) return "' . $lang . '"; 
				if(!_paga_language_ || !_paga_language_[id]) return default_text;
				return _paga_language_[id];
			}
		</script>
';
}

$lang = new language($lang);
$lang->load(ROOT_DIR, '.json');

function _lang($id, $default_text)
{
	global $lang;

	return $lang->dump($id, $default_text);
}

function _langvp($id, $data)
{
	global $lang;

	return $lang->format($id, $data);
}
*/

function get_sshport()
{
	$sshd_enable = 0;
	$dropbear_enable = 0;
	$fp = fopen('/etc/rc.conf', 'r');
	if($fp) {
		while (!feof($fp)) {
			if(($buf = fgets($fp)) === false)
				break;
			if(empty($buf = trim($buf)))
				continue;
			$buf = strtoupper($buf);
			if(strpos($buf, "SSHD_ENABLE=") === 0) {
				$val = trim(substr($buf, 12), " \t\n\r\0\x0B\"");
				if($val == "YES" || intval($val))
					$sshd_enable = 1;
				else
					$sshd_enable = 0;
				continue;
			}

			if(strpos($buf, "DROPBEAR_ENABLE=") === 0) {
				$val = trim(substr($buf, 16), " \t\n\r\0\x0B\"");
				if($val == "YES" || intval($val))
					$dropbear_enable = 1;
				else
					$dropbear_enable = 0;
				continue;
			}
		}
		fclose($fp);
	}
	
	$port = 22;
	if($sshd_enable) {
		$file = '/usr/logd/etc/dropbear/dropbear.conf';
		if(file_exists($file)) {
			$fp = fopen($file, 'r');
			if($fp) {
				while (!feof($fp)) {
					if(($buf = fgets($fp)) === false)
						break;
					if(empty($buf = trim($buf)))
						continue;
					if(strpos($buf, 'Port ') === 0) 
						$port = intval(trim(substr($buf, 5), " \t\n\r\0\x0B\""));
				}
				fclose($fp);
			}
		}
		return $port;
	}

	if($dropbear_enable) {
		$file = '/usr/logd/etc/dropbear/dropbear.conf';
		if(file_exists($file)) {
			$fp = fopen($file, 'r');
			if($fp) {
				while (!feof($fp)) {
					if(($buf = fgets($fp)) === false)
						break;
					if(empty($buf = trim($buf)))
						continue;
					$buf = strtoupper($buf);
					if(strpos($buf, 'PORT=') === 0) 
						$port = intval(trim(substr($buf, 5), " \t\n\r\0\x0B\""));
				}
				fclose($fp);
			}
		}

		return $port;
	}

	return $port;
}


function listen_port_freebsd($ip)
{
	// $ip = '*' or $ip = '127.0.0.1'
	$ports = array();

	// n=端口号转成数字 a=显示所有接口 4=ipv4 L=listen
	$cmd = "netstat -anL4";
	exec($cmd, $out, $ret);
	if($ret == 0) {
/*
Current listen queue sizes (qlen/incqlen/maxqlen)
Proto Listen                           Local Address
tcp4  0/0/128                          *.60443
tcp4  0/0/128                          *.24569
tcp4  0/0/128                          127.0.0.1.9000
tcp46 0/0/80                           *.3306
tcp4  0/0/128                          *.443
tcp4  0/0/128                          *.22
*/
		if($ip) {
			foreach($out as $line) {
				$line = preg_split('/ +/', $line);
				if(count($line) != 3 
				|| $line[0] != 'tcp4')
					continue;
				$cols = explode('.', $line[2]);
				if(count($cols) == 2 && $cols[0] == $ip) {
					array_push($ports, intval($cols[1]));
				}
			}
		}
		else {
			foreach($out as $line) {
				$line = preg_split('/ +/', $line);
				if(count($line) != 3 
				|| $line[0] != 'tcp4')
					continue;
				$cols = explode('.', $line[2]);
				if(count($cols) == 2) {
					array_push($ports, intval($cols[1]));
				}
			}
		}
	}

	return $ports;
}

function listen_port_linux($ip)
{
	// $ip = '*' or $ip = '127.0.0.1'
	$ports = array();

	// n=端口号转成数字 t=tcp 4=ipv4 l=listen
	$cmd = "netstat -nlt4";
	exec($cmd, $out, $ret);
	if($ret == 0) {
/*
Active Internet connections (only servers)
Proto Recv-Q Send-Q Local Address           Foreign Address         State
tcp        0      0 0.0.0.0:50022           0.0.0.0:*               LISTEN
tcp        0      0 127.0.0.1:9000          0.0.0.0:*               LISTEN
tcp        0      0 0.0.0.0:22              0.0.0.0:*               LISTEN
tcp        0      0 0.0.0.0:8791            0.0.0.0:*               LISTEN
tcp        0      0 0.0.0.0:60443           0.0.0.0:*               LISTEN
tcp        0      0 0.0.0.0:443             0.0.0.0:*               LISTEN
*/
		if($ip) {
			foreach($out as $line) {
				$line = preg_split('/ +/', $line);
				if(count($line) != 6
				|| $line[0] != 'tcp')
					continue;
				$cols = explode(':', $line[3]);
				if(count($cols) == 2 && $cols[0] == $ip) {
					array_push($ports, intval($cols[1]));
				}
			}
		}
		else {
			foreach($out as $line) {
				$line = preg_split('/ +/', $line);
				if(count($line) != 6
				|| $line[0] != 'tcp')
					continue;
				$cols = explode(':', $line[3]);
				if(count($cols) == 2) {
					array_push($ports, intval($cols[1]));
				}
			}
		}
	}

	return $ports;
}

function hav_listenport($port)
{
	if(PHP_OS == "Linux")
		$ports = listen_port_linux(0);
	else
		$ports = listen_port_freebsd(0);

	return in_array($port, $ports);
}
